var __defProp = Object.defineProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var __accessCheck = (obj, member, msg) => {
  if (!member.has(obj))
    throw TypeError("Cannot " + msg);
};
var __privateGet = (obj, member, getter) => {
  __accessCheck(obj, member, "read from private field");
  return getter ? getter.call(obj) : member.get(obj);
};
var __privateAdd = (obj, member, value) => {
  if (member.has(obj))
    throw TypeError("Cannot add the same private member more than once");
  member instanceof WeakSet ? member.add(obj) : member.set(obj, value);
};
var __privateSet = (obj, member, value, setter) => {
  __accessCheck(obj, member, "write to private field");
  setter ? setter.call(obj, value) : member.set(obj, value);
  return value;
};
var __privateMethod = (obj, member, method) => {
  __accessCheck(obj, member, "access private method");
  return method;
};
var _a, _b, _session, _user, _shareToken, _currentDirectory, _attachmentDirectory, _getImageAttachmentUrl, getImageAttachmentUrl_fn, _getMediaPreviewUrl, getMediaPreviewUrl_fn, _textApiParams, textApiParams_fn, _previewUrl, previewUrl_fn, _davUrl, davUrl_fn, _relativePath, relativePath_fn, _filePath, filePath_fn;
import { Editor, Node, Extension, getExtensionField, InputRule, wrappingInputRule, mergeAttributes, isNodeActive, Mark, markInputRule, markPasteRule } from "@tiptap/core";
import { EditorContent, NodeViewWrapper, NodeViewContent, VueNodeViewRenderer, VueRenderer, nodeViewProps } from "@tiptap/vue-2";
import { getLoggerBuilder } from "@nextcloud/logger";
import debounce from "debounce";
import { NcButton, emojiAddRecent, emojiSearch, NcModal, NcUserBubble, NcActionButton, NcActions } from "@nextcloud/vue";
import Vuex, { Store, mapState } from "vuex";
import Vue, { defineComponent } from "vue";
import { getBuilder } from "@nextcloud/browser-storage";
import "vue-material-design-icons/AlphabeticalVariant.vue";
import MDI_Close from "vue-material-design-icons/Close.vue";
import "vue-material-design-icons/Check.vue";
import "vue-material-design-icons/CircleMedium.vue";
import "vue-material-design-icons/CodeTags.vue";
import MDI_Danger from "vue-material-design-icons/AlertDecagram.vue";
import MDI_Delete from "vue-material-design-icons/Delete.vue";
import "vue-material-design-icons/FileDocument.vue";
import "vue-material-design-icons/DotsHorizontal.vue";
import "vue-material-design-icons/EmoticonOutline.vue";
import "vue-material-design-icons/Folder.vue";
import "vue-material-design-icons/FormatBold.vue";
import MDI_AlignHorizontalCenter from "vue-material-design-icons/AlignHorizontalCenter.vue";
import MDI_AlignHorizontalLeft from "vue-material-design-icons/AlignHorizontalLeft.vue";
import MDI_AlignHorizontalRight from "vue-material-design-icons/AlignHorizontalRight.vue";
import "vue-material-design-icons/FormatHeader1.vue";
import "vue-material-design-icons/FormatHeader2.vue";
import "vue-material-design-icons/FormatHeader3.vue";
import "vue-material-design-icons/FormatHeader4.vue";
import "vue-material-design-icons/FormatHeader5.vue";
import "vue-material-design-icons/FormatHeader6.vue";
import "vue-material-design-icons/FormatItalic.vue";
import "vue-material-design-icons/FormatListBulleted.vue";
import "vue-material-design-icons/FormatListCheckbox.vue";
import "vue-material-design-icons/FormatListNumbered.vue";
import "vue-material-design-icons/FormatQuoteClose.vue";
import "vue-material-design-icons/FormatStrikethrough.vue";
import "vue-material-design-icons/FormatUnderline.vue";
import "vue-material-design-icons/HelpCircle.vue";
import MDI_Image from "vue-material-design-icons/ImageOutline.vue";
import "vue-material-design-icons/ImageMultipleOutline.vue";
import MDI_Info from "vue-material-design-icons/Information.vue";
import "vue-material-design-icons/Link.vue";
import "vue-material-design-icons/LinkOff.vue";
import "vue-material-design-icons/LinkVariantPlus.vue";
import "vue-material-design-icons/Loading.vue";
import "vue-material-design-icons/Lock.vue";
import MDI_Positive from "vue-material-design-icons/CheckboxMarkedCircle.vue";
import "vue-material-design-icons/ArrowURightTop.vue";
import "vue-material-design-icons/Table.vue";
import MDI_TableAddColumnAfter from "vue-material-design-icons/TableColumnPlusAfter.vue";
import MDI_TableAddColumnBefore from "vue-material-design-icons/TableColumnPlusBefore.vue";
import MDI_TableAddRowAfter from "vue-material-design-icons/TableRowPlusAfter.vue";
import MDI_TableAddRowBefore from "vue-material-design-icons/TableRowPlusBefore.vue";
import MDI_TableSettings from "vue-material-design-icons/TableCog.vue";
import "vue-material-design-icons/TrashCan.vue";
import "vue-material-design-icons/ArrowULeftTop.vue";
import "vue-material-design-icons/Upload.vue";
import MDI_Warn from "vue-material-design-icons/Alert.vue";
import "vue-material-design-icons/Web.vue";
import "vue-material-design-icons/TranslateVariant.vue";
import { PluginKey, Plugin, TextSelection } from "@tiptap/pm/state";
import Suggestion, { Suggestion as Suggestion$1 } from "@tiptap/suggestion";
import { DecorationSet, Decoration } from "@tiptap/pm/view";
import { defaultMarkdownSerializer } from "@tiptap/pm/markdown";
import MarkdownIt from "markdown-it";
import taskLists from "@hedgedoc/markdown-it-task-lists";
import markdownitMentions from "@quartzy/markdown-it-mentions";
import container from "markdown-it-container";
import markdownitNewline from "markdown-it/lib/rules_inline/newline.js";
import markdownitEscape from "markdown-it/lib/rules_inline/escape.js";
import frontMatter from "markdown-it-front-matter";
import implicitFigures from "markdown-it-image-figures";
import { escapeHtml } from "markdown-it/lib/common/utils.js";
import { DOMParser } from "@tiptap/pm/model";
import Text from "@tiptap/extension-text";
import History from "@tiptap/extension-history";
import Blockquote from "@tiptap/extension-blockquote";
import TiptapBulletList from "@tiptap/extension-bullet-list";
import CharacterCount from "@tiptap/extension-character-count";
import Code from "@tiptap/extension-code";
import TiptapCodeBlock from "@tiptap/extension-code-block";
import Document from "@tiptap/extension-document";
import Dropcursor from "@tiptap/extension-dropcursor";
import tippy from "tippy.js";
import { translate } from "@nextcloud/l10n";
import TiptapParagraph from "@tiptap/extension-paragraph";
import { getCurrentUser } from "@nextcloud/auth";
import { NcReferenceList, getLinkWithPicker, searchProvider } from "@nextcloud/vue/dist/Components/NcRichText.js";
import TipTapHardBreak from "@tiptap/extension-hard-break";
import TipTapHeading from "@tiptap/extension-heading";
import slugify from "slug";
import { v4 } from "uuid";
import HorizontalRule from "@tiptap/extension-horizontal-rule";
import TiptapImage from "@tiptap/extension-image";
import axios from "@nextcloud/axios";
import ClickOutside from "vue-click-outside";
import { emit } from "@nextcloud/event-bus";
import { generateUrl, generateRemoteUrl } from "@nextcloud/router";
import ListItem from "@tiptap/extension-list-item";
import TipTapMention from "@tiptap/extension-mention";
import OrderedList from "@tiptap/extension-ordered-list";
import Placeholder from "@tiptap/extension-placeholder";
import { Table as Table$1 } from "@tiptap/extension-table";
import { TableCell as TableCell$1 } from "@tiptap/extension-table-cell";
import { TableHeader as TableHeader$1 } from "@tiptap/extension-table-header";
import { TableRow as TableRow$1 } from "@tiptap/extension-table-row";
import { addRowAfter, selectedRect, addRowBefore, isInTable, selectionCell, moveCellForward } from "@tiptap/pm/tables";
import TipTapTaskItem from "@tiptap/extension-task-item";
import TiptapTaskList from "@tiptap/extension-task-list";
import TipTapItalic from "@tiptap/extension-italic";
import TipTapLink from "@tiptap/extension-link";
import TipTapStrike from "@tiptap/extension-strike";
import { Bold, starInputRegex, starPasteRegex, underscoreInputRegex, underscorePasteRegex } from "@tiptap/extension-bold";
import TipTapUnderline from "@tiptap/extension-underline";
import pathNormalize from "path-normalize";
import { formatFileSize } from "@nextcloud/files";
const logger = getLoggerBuilder().setApp("text").detectUser().build();
/**
 * @copyright Copyright (c) 2022 Vinicius Reis <vinicius@nextcloud.com>
 *
 * @author Vinicius Reis <vinicius@nextcloud.com>
 *
 * @license AGPL-3.0-or-later
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const EDITOR = Symbol("tiptap:editor");
const ATTACHMENT_RESOLVER = Symbol("attachment:resolver");
const useEditorMixin = {
  inject: {
    $editor: { from: EDITOR, default: null }
  }
};
const useAttachmentResolver = {
  inject: {
    $attachmentResolver: {
      from: ATTACHMENT_RESOLVER,
      default: {
        resolve(src) {
          logger.warn("No attachment resolver provided. Some attachment sources cannot be resolved.");
          return [src];
        }
      }
    }
  }
};
const OUTLINE_STATE = Symbol("wrapper:outline-state");
const OUTLINE_ACTIONS = Symbol("wrapper:outline-actions");
const useOutlineStateMixin = {
  inject: {
    $outlineState: {
      from: OUTLINE_STATE,
      default: {
        visible: false,
        enable: false
      }
    }
  }
};
const useOutlineActions = {
  inject: {
    $outlineActions: {
      from: OUTLINE_ACTIONS,
      default: {
        toggle: () => {
        }
      }
    }
  }
};
const SET_VIEW_WIDTH = "SET_VIEW_WIDTH";
const SET_SHOW_AUTHOR_ANNOTATIONS = "SET_SHOW_AUTHOR_ANNOTATIONS";
const SET_CURRENT_SESSION = "SET_CURRENT_SESSION";
const SET_HEADINGS = "SET_HEADINGS";
/**
 * @copyright Copyright (c) 2022 Vinicius Reis <vinicius@nextcloud.com>
 *
 * @author Vinicius Reis <vinicius@nextcloud.com>
 *
 * @license AGPL-3.0-or-later
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const getClientWidth = () => document.documentElement.clientWidth;
const plugin = ({ commit }) => {
  const onResize = debounce(() => {
    commit(`text/${SET_VIEW_WIDTH}`, getClientWidth());
  }, 100);
  window.addEventListener("resize", onResize);
};
/*
 * @copyright Copyright (c) 2020 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const persistentStorage = getBuilder("text").persist().build();
Vue.use(Vuex);
const textModule = {
  state: {
    showAuthorAnnotations: persistentStorage.getItem("showAuthorAnnotations") === "true",
    currentSession: persistentStorage.getItem("currentSession"),
    viewWidth: getClientWidth(),
    headings: Object.freeze([])
  },
  mutations: {
    [SET_VIEW_WIDTH](state, value) {
      state.viewWidth = value;
    },
    [SET_SHOW_AUTHOR_ANNOTATIONS](state, value) {
      state.showAuthorAnnotations = value;
      persistentStorage.setItem("showAuthorAnnotations", "" + value);
    },
    [SET_CURRENT_SESSION](state, value) {
      state.currentSession = value;
      persistentStorage.setItem("currentSession", value);
    },
    [SET_HEADINGS](state, value) {
      if (state.headings.length !== value.length) {
        state.headings = Object.freeze(value);
        return;
      }
      const old = state.headings;
      const headings = value.map((row, index) => {
        const previous = old[index].level;
        return Object.freeze({
          ...row,
          previous
        });
      });
      state.headings = Object.freeze(headings);
    }
  },
  actions: {
    setShowAuthorAnnotations({ commit }, value) {
      commit(SET_SHOW_AUTHOR_ANNOTATIONS, value);
    },
    setCurrentSession({ commit }, value) {
      commit(SET_CURRENT_SESSION, value);
    },
    setHeadings({ commit }, value) {
      commit(SET_HEADINGS, value);
    }
  }
};
const store$1 = new Store({
  plugins: [plugin],
  modules: {
    text: {
      namespaced: true,
      ...textModule
    }
  }
});
/*
 * @copyright Copyright (c) 2021 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const store = {
  data() {
    return {
      $store: store$1
    };
  },
  beforeMount() {
    if (typeof this.$store === "undefined") {
      this.$store = store$1;
    } else if (!this.$store.hasModule("text")) {
      this.$store.registerModule("text", textModule);
    }
  }
};
const TableOfContents_vue_vue_type_style_index_0_lang = "";
function normalizeComponent(scriptExports, render18, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render18) {
    options.render = render18;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  if (functionalTemplate) {
    options.functional = true;
  }
  if (scopeId) {
    options._scopeId = "data-v-" + scopeId;
  }
  var hook;
  if (moduleIdentifier) {
    hook = function(context) {
      context = context || // cached call
      this.$vnode && this.$vnode.ssrContext || // stateful
      this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext;
      if (!context && typeof __VUE_SSR_CONTEXT__ !== "undefined") {
        context = __VUE_SSR_CONTEXT__;
      }
      if (injectStyles) {
        injectStyles.call(this, context);
      }
      if (context && context._registeredComponents) {
        context._registeredComponents.add(moduleIdentifier);
      }
    };
    options._ssrRegister = hook;
  } else if (injectStyles) {
    hook = shadowMode ? function() {
      injectStyles.call(
        this,
        (options.functional ? this.parent : this).$root.$options.shadowRoot
      );
    } : injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}
const _sfc_main$g = {
  name: "TableOfContents",
  mixins: [store, useEditorMixin],
  data: () => ({
    initialRender: true
  }),
  computed: {
    ...mapState({
      headings: (state) => state.text.headings
    })
  },
  mounted() {
    setTimeout(() => {
      this.initialRender = false;
    }, 1e3);
  },
  methods: {
    goto(heading) {
      this.$editor.chain().focus().setTextSelection(heading.position).scrollIntoView().run();
      this.$nextTick(() => {
        window.location.hash = heading.id;
      });
    }
  }
};
var _sfc_render$g = function render() {
  var _vm = this, _c = _vm._self._c;
  return _c("div", { staticClass: "editor--toc", class: { "--initial-render": _vm.initialRender }, attrs: { "data-text-el": "editor-table-of-contents" } }, [_c("ul", { staticClass: "editor--toc__list" }, _vm._l(_vm.headings, function(heading) {
    return _c("li", { key: heading.uuid, staticClass: "editor--toc__item", class: {
      [`editor--toc__item--${heading.level}`]: true,
      [`editor--toc__item--previous-${heading.previous}`]: heading.previous > 0
    }, attrs: { "data-toc-level": heading.level } }, [_c("a", { attrs: { "href": `#${heading.id}` }, on: { "click": function($event) {
      $event.preventDefault();
      return _vm.goto(heading);
    } } }, [_vm._v(" " + _vm._s(heading.text) + " ")])]);
  }), 0)]);
};
var _sfc_staticRenderFns$g = [];
var __component__$g = /* @__PURE__ */ normalizeComponent(
  _sfc_main$g,
  _sfc_render$g,
  _sfc_staticRenderFns$g,
  false,
  null,
  null,
  null,
  null
);
const TableOfContents = __component__$g.exports;
const DEFAULT_ICON_SIZE = 20;
const makeIcon = (original) => ({
  functional: true,
  render(h, { data, props }) {
    return h(original, {
      data,
      key: data.key,
      staticClass: data.staticClass,
      props: { size: DEFAULT_ICON_SIZE, ...props }
    });
  }
});
const AlignHorizontalCenter = makeIcon(MDI_AlignHorizontalCenter);
const AlignHorizontalLeft = makeIcon(MDI_AlignHorizontalLeft);
const AlignHorizontalRight = makeIcon(MDI_AlignHorizontalRight);
const Close = makeIcon(MDI_Close);
const Danger = makeIcon(MDI_Danger);
const Delete = makeIcon(MDI_Delete);
const Image$2 = makeIcon(MDI_Image);
const Info = makeIcon(MDI_Info);
const Positive = makeIcon(MDI_Positive);
const TableAddColumnAfter = makeIcon(MDI_TableAddColumnAfter);
const TableAddColumnBefore = makeIcon(MDI_TableAddColumnBefore);
const TableAddRowAfter = makeIcon(MDI_TableAddRowAfter);
const TableAddRowBefore = makeIcon(MDI_TableAddRowBefore);
const TableSettings = makeIcon(MDI_TableSettings);
const Warn = makeIcon(MDI_Warn);
const EditorOutline_vue_vue_type_style_index_0_scoped_0c9e1c76_lang = "";
const _sfc_main$f = {
  name: "EditorOutline",
  components: {
    Close,
    NcButton,
    TableOfContents
  },
  mixins: [store, useOutlineStateMixin, useOutlineActions],
  data: () => ({
    mobile: false
  }),
  mounted() {
    this.$onResize = debounce(() => {
      this.mobile = this.$el.parentElement.clientWidth < 320;
    }, 10);
    this.$resizeObserver = new ResizeObserver(this.$onResize);
    this.$resizeObserver.observe(this.$el.parentElement);
    this.$onResize();
  },
  beforeDestroy() {
    this.$resizeObserver.unobserve(this.$el.parentElement);
    this.$resizeObserver = null;
    this.$onResize = null;
  }
};
var _sfc_render$f = function render2() {
  var _vm = this, _c = _vm._self._c;
  return _c("div", { staticClass: "editor--outline", class: { "editor--outline-mobile": _vm.mobile }, attrs: { "data-text-el": "editor-outline" } }, [_c("header", { staticClass: "editor--outline__header" }, [_c("NcButton", { staticClass: "editor--outline__btn-close", attrs: { "type": "tertiary", "aria-label": _vm.t("text", "Close outline view") }, on: { "click": _vm.$outlineActions.toggle }, scopedSlots: _vm._u([{ key: "icon", fn: function() {
    return [_c("Close")];
  }, proxy: true }]) }), _c("h2", [_vm._v(_vm._s(_vm.t("text", "Outline")))])], 1), _c("TableOfContents")], 1);
};
var _sfc_staticRenderFns$f = [];
var __component__$f = /* @__PURE__ */ normalizeComponent(
  _sfc_main$f,
  _sfc_render$f,
  _sfc_staticRenderFns$f,
  false,
  null,
  "0c9e1c76",
  null,
  null
);
const EditorOutline = __component__$f.exports;
const BaseReader_vue_vue_type_style_index_0_scoped_20572680_lang = "";
const _sfc_main$e = {
  name: "BaseReader",
  components: {
    EditorContent,
    EditorOutline
  },
  mixins: [useOutlineStateMixin, useOutlineActions],
  provide() {
    const val = {};
    Object.defineProperties(val, {
      [EDITOR]: {
        get: () => this.$editor
      }
    });
    return val;
  },
  // extensions is a factory building a list of extensions for the editor
  inject: ["renderHtml", "extensions"],
  props: {
    content: {
      type: String,
      required: true
    }
  },
  computed: {
    htmlContent() {
      return this.renderHtml(this.content);
    },
    showOutline() {
      return this.$outlineState.visible;
    }
  },
  watch: {
    content() {
      this.updateContent();
    }
  },
  created() {
    this.$editor = this.createEditor();
    this.$editor.setOptions({ editable: false });
  },
  beforeDestroy() {
    this.$editor.destroy();
  },
  methods: {
    createEditor() {
      return new Editor({
        content: this.htmlContent,
        extensions: this.extensions()
      });
    },
    updateContent() {
      this.$editor.commands.setContent(this.htmlContent, true);
    }
  }
};
var _sfc_render$e = function render3() {
  var _vm = this, _c = _vm._self._c;
  return _c("div", { staticClass: "content-wrapper text-editor__content-wrapper", class: {
    "--show-outline": _vm.showOutline
  }, attrs: { "data-text-el": "editor-content-wrapper" } }, [_vm.showOutline ? _c("div", { staticClass: "text-editor__content-wrapper__left" }, [_c("EditorOutline")], 1) : _vm._e(), _vm.$editor ? _c("EditorContent", { staticClass: "editor__content text-editor__content", attrs: { "id": "read-only-editor", "editor": _vm.$editor } }) : _vm._e(), _c("div", { staticClass: "text-editor__content-wrapper__right" })], 1);
};
var _sfc_staticRenderFns$e = [];
var __component__$e = /* @__PURE__ */ normalizeComponent(
  _sfc_main$e,
  _sfc_render$e,
  _sfc_staticRenderFns$e,
  false,
  null,
  "20572680",
  null,
  null
);
const BaseReader = __component__$e.exports;
/*
 * @copyright Copyright (c) 2021 Jonas <jonas@freesources.org>
 *
 * @author Jonas <jonas@freesources.org>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const EmojiPluginKey = new PluginKey("emoji");
const Emoji = Node.create({
  name: "emoji",
  addOptions() {
    return {
      HTMLAttributes: {},
      suggestion: {
        char: ":",
        allowedPrefixes: [" "],
        pluginKey: EmojiPluginKey
      }
    };
  },
  content: "text*",
  addCommands() {
    return {
      emoji: (emojiObject) => ({ commands }) => {
        return commands.insertContent(emojiObject.native + " ");
      }
    };
  },
  addProseMirrorPlugins() {
    return [
      Suggestion({
        editor: this.editor,
        ...this.options.suggestion
      })
    ];
  }
});
/*
 * @copyright Copyright (c) 2019 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
Extension.create({
  name: "customkeymap",
  addKeyboardShortcuts() {
    return this.options;
  },
  addProseMirrorPlugins() {
    return [
      new Plugin({
        props: {
          handleKeyDown(view, event) {
            const key = event.key || event.keyCode;
            if ((event.ctrlKey || event.metaKey) && !event.shiftKey && (key === "f" || key === 70)) {
              event.stopPropagation();
              window.dispatchEvent(event);
              return true;
            }
            if (event.key === "Delete" && event.ctrlKey === true) {
              event.stopPropagation();
              window.dispatchEvent(event);
              return true;
            }
          }
        }
      })
    ];
  }
});
/*
 * @copyright Copyright (c) 2020 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
class Span {
  constructor(from, to, author) {
    this.from = from;
    this.to = to;
    this.author = author;
  }
}
/*
 * @copyright Copyright (c) 2021 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
function updateBlameMap(map, transform, clientIDs) {
  const result = [];
  const mapping = transform.mapping;
  for (let i = 0; i < map.length; i++) {
    const span = map[i];
    const from = mapping.map(span.from, 1);
    const to = mapping.map(span.to, -1);
    if (from < to)
      result.push(new Span(from, to, span.author));
  }
  for (let i = 0; i < mapping.maps.length; i++) {
    const map2 = mapping.maps[i];
    const after = mapping.slice(i + 1);
    map2.forEach((_s, _e, start, end) => {
      insertIntoBlameMap(result, after.map(start, 1), after.map(end, -1), clientIDs[i]);
    });
  }
  return result;
}
function insertIntoBlameMap(map, from, to, author) {
  if (from >= to) {
    return;
  }
  let pos = 0;
  let next;
  for (; pos < map.length; pos++) {
    next = map[pos];
    if (next.author === author) {
      if (next.to >= from)
        break;
    } else if (next.to > from) {
      if (next.from < from) {
        const left = new Span(next.from, from, next.author);
        if (next.to > to)
          map.splice(pos++, 0, left);
        else
          map[pos++] = left;
      }
      break;
    }
  }
  while (next = map[pos]) {
    if (next.author === author) {
      if (next.from > to)
        break;
      from = Math.min(from, next.from);
      to = Math.max(to, next.to);
      map.splice(pos, 1);
    } else {
      if (next.from >= to)
        break;
      if (next.to > to) {
        map[pos] = new Span(to, next.to, next.author);
        break;
      } else {
        map.splice(pos, 1);
      }
    }
  }
  map.splice(pos, 0, new Span(from, to, author));
}
class TrackState {
  constructor(blameMap) {
    this.blameMap = blameMap;
  }
  // Apply a transform to this state
  applyTransform(transform) {
    const clientID = transform.getMeta("clientID") ?? transform.steps.map((item) => "self");
    const newBlame = updateBlameMap(this.blameMap, transform, clientID);
    return new TrackState(newBlame);
  }
}
/*
 * @copyright Copyright (c) 2020 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
Extension.create({
  name: "users",
  addOptions() {
    return {
      clientID: 0,
      color: (clientID) => {
        return "#" + Math.floor(Math.abs(Math.sin(clientID) * 16777215) % 16777215).toString(16) + "aa";
      },
      name: (clientID) => {
        return "Unknown user " + clientID;
      }
    };
  },
  addProseMirrorPlugins() {
    let viewReference = null;
    return [
      new Plugin({
        clientID: this.options.clientID,
        color: this.options.color,
        name: this.options.name,
        view: (editorView) => {
          viewReference = editorView;
          return {};
        },
        state: {
          init(_, instance) {
            return {
              tracked: new TrackState([new Span(0, instance.doc.content.size, null)], [], [], []),
              deco: DecorationSet.empty
            };
          },
          apply(tr, instance, oldState, state) {
            let { tracked, decos } = instance;
            let tState = this.getState(oldState).tracked;
            if (tr.docChanged) {
              if (!tr.getMeta("clientID")) {
                tr.setMeta("clientID", tr.steps.map((i) => this.spec.clientID));
              }
              if (!viewReference.composing) {
                tracked = tracked.applyTransform(tr);
                tState = tracked;
              }
            }
            decos = tState.blameMap.map((span) => {
              const clientID = span.author;
              return Decoration.inline(span.from, span.to, {
                class: "author-annotation",
                style: "background-color: " + this.spec.color(clientID) + "66;",
                title: this.spec.name(clientID)
              });
            }).filter((dec) => dec !== null);
            return { tracked, deco: DecorationSet.create(state.doc, decos) };
          }
        },
        props: {
          decorations(state) {
            return this.getState(state).deco;
          }
        }
      })
    ];
  }
});
/*
 * @copyright Copyright (c) 2022 Max <max@nextcloud.com>
 *
 * @author Max <max@nextcloud.com>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
function markdownUnderlines(md) {
  md.inline.ruler2.after("emphasis", "underline", (state) => {
    const tokens = state.tokens;
    for (let i = tokens.length - 1; i > 0; i--) {
      const token = tokens[i];
      if (token.markup === "__") {
        if (token.type === "strong_open") {
          tokens[i].tag = "u";
          tokens[i].type = "u_open";
        }
        if (token.type === "strong_close") {
          tokens[i].tag = "u";
          tokens[i].type = "u_close";
        }
      }
    }
    return false;
  });
}
/*
 * @copyright Copyright (c) 2022 Max <max@nextcloud.com>
 *
 * @author Max <max@nextcloud.com>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
function splitMixedLists(md) {
  md.core.ruler.after("task-lists", "split-mixed-task-lists", (state) => {
    const tokens = state.tokens;
    for (let i = 0; i < tokens.length; i++) {
      const token = tokens[i];
      if (!includesClass(token, "contains-task-list")) {
        continue;
      }
      const firstChild = tokens[i + 1];
      const startsWithTask = includesClass(firstChild, "task-list-item");
      if (!startsWithTask) {
        token.attrs.splice(token.attrIndex("class"));
        if (token.attrs.length === 0) {
          token.attrs = null;
        }
      }
      const splitBefore = findChildOf(tokens, i, (child) => {
        return child.nesting === 1 && includesClass(child, "task-list-item") !== startsWithTask;
      });
      if (splitBefore > i) {
        splitListAt(tokens, splitBefore, state.Token);
      }
    }
    return false;
  });
}
function includesClass(token, cls) {
  var _a2;
  return ((_a2 = token.attrGet("class")) == null ? void 0 : _a2.split(" ").includes(cls)) || false;
}
function splitListAt(tokens, index, TokenConstructor) {
  const closeList = new TokenConstructor("bullet_list_close", "ul", -1);
  closeList.block = true;
  const openList = new TokenConstructor("bullet_list_open", "ul", 1);
  openList.attrSet("class", "contains-task-list");
  openList.block = true;
  openList.markup = tokens[index].markup;
  tokens.splice(index, 0, closeList, openList);
}
function findChildOf(tokens, parentIndex, predicate) {
  const searchLevel = tokens[parentIndex].level + 1;
  for (let i = parentIndex + 1; i < tokens.length; i++) {
    const token = tokens[i];
    if (token.level < searchLevel) {
      return -1;
    }
    if (token.level === searchLevel && predicate(tokens[i])) {
      return i;
    }
  }
  return -1;
}
/*
 * @copyright Copyright (c) 2022 Vinicius Reis <vinicius@nextcloud.com>
 *
 * @author Vinicius Reis <vinicius@nextcloud.com>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const typesAvailable = ["info", "warn", "error", "success"];
const buildRender = (type) => (tokens, idx, options, env, slf) => {
  const tag = tokens[idx];
  if (tag.nesting === 1) {
    tag.attrSet("data-callout", type);
    tag.attrJoin("class", `callout callout-${type}`);
  }
  return slf.renderToken(tokens, idx, options, env, slf);
};
const callouts = (md) => {
  typesAvailable.forEach((type) => {
    md.use(container, type, {
      render: buildRender(type)
    });
  });
  return md;
};
/**
 * @copyright Copyright (c) 2022
 *
 * @author Ferdinand Thiessen <rpm@fthiessen.de>
 *
 * @license AGPL-3.0-or-later
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
function keepHardbreakSyntax(md) {
  md.inline.ruler.at("newline", (state, silent) => {
    const rval = markdownitNewline(state, silent);
    if (rval && state.tokens.length && state.tokens[state.tokens.length - 1].type === "hardbreak")
      state.tokens[state.tokens.length - 1].attrSet("syntax", "  ");
    return rval;
  });
  md.inline.ruler.at("escape", (state, silent) => {
    const rval = markdownitEscape(state, silent);
    if (rval && state.tokens.length && state.tokens[state.tokens.length - 1].type === "hardbreak")
      state.tokens[state.tokens.length - 1].attrSet("syntax", "\\");
    return rval;
  });
  md.inline.ruler.after("html_inline", "html_breaks", (state) => {
    const res = state.src.slice(state.pos).match(/^\s*<br\s*\/?>/);
    if (res) {
      const token = state.push("hardbreak", "br", 0);
      token.attrPush(["syntax", "html"]);
      state.pos += res[0].length;
      return true;
    }
    return false;
  });
  md.renderer.rules.hardbreak = (tokens, idx, options) => `<br data-syntax="${tokens[idx].attrGet("syntax")}" ${options.xhtmlOut ? "/" : ""}>`;
}
/**
 * @copyright Copyright (c) 2022
 *
 * @license AGPL-3.0-or-later
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
function keepSyntax(md) {
  const escaped = /(\n(?<linestart>[#\-*+>])|(?<special>[`*\\~[\]]+))/;
  md.core.ruler.before("text_join", "tag-markdown-syntax", (state) => {
    const open = new state.Token("keep_md_open", "span", 1);
    open.attrSet("class", "keep-md");
    const close = new state.Token("keep_md_close", "span", -1);
    for (let i = 0; i < state.tokens.length; i++) {
      const block = state.tokens[i];
      if (block.type !== "inline")
        continue;
      for (let j = 0; j < block.children.length; j++) {
        const token = block.children[j];
        if (token.type === "text") {
          const match = escaped.exec(token.content);
          if (match) {
            const index = match.groups.linestart ? match.index + 1 : match.index;
            const matchChars = match.groups.linestart ?? match.groups.special;
            const contentNext = index + matchChars.length;
            block.children.splice(
              j,
              1,
              Object.assign({}, token, { content: token.content.slice(0, index) }),
              Object.assign({}, open),
              Object.assign({}, token, { content: token.content.slice(index, contentNext) }),
              Object.assign({}, close),
              Object.assign({}, token, { content: token.content.slice(contentNext) })
            );
            j += 3;
          }
        }
      }
    }
    return false;
  });
}
const markdownit = MarkdownIt("commonmark", { html: false, breaks: false }).enable("strikethrough").enable("table").use(taskLists, { enable: true, labelAfter: true }).use(frontMatter, (fm) => {
}).use(splitMixedLists).use(markdownUnderlines).use(keepHardbreakSyntax).use(callouts).use(keepSyntax).use(markdownitMentions).use(implicitFigures);
markdownit.renderer.rules.front_matter = (tokens, idx, options) => `<pre id="frontmatter"><code>${escapeHtml(tokens[idx].meta)}</code></pre>`;
markdownit.renderer.rules.bullet_list_open = (tokens, idx, options) => {
  tokens[idx].attrs = [
    ...tokens[idx].attrs || [],
    ["data-bullet", tokens[idx].markup]
  ];
  return markdownit.renderer.renderToken(tokens, idx, options);
};
/**
 * @copyright Copyright (c) 2022 Max <max@nextcloud.com>
 *
 * @author Max <max@nextcloud.com>
 *
 * @license AGPL-3.0-or-later
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const Markdown = Extension.create({
  name: "markdown",
  extendMarkSchema(extension) {
    const context = {
      name: extension.name,
      options: extension.options,
      storage: extension.storage
    };
    return {
      toMarkdown: getExtensionField(extension, "toMarkdown", context)
    };
  },
  extendNodeSchema(extension) {
    const context = {
      name: extension.name,
      options: extension.options,
      storage: extension.storage
    };
    return {
      toMarkdown: getExtensionField(extension, "toMarkdown", context)
    };
  },
  addProseMirrorPlugins() {
    let shiftKey = false;
    return [
      // Parse markdown unless Mod+Shift+V is pressed for text clipboard content
      new Plugin({
        key: new PluginKey("pasteEventHandler"),
        props: {
          handleDOMEvents: {
            mouseup(_, event) {
              shiftKey = event.shiftKey;
              return false;
            }
          },
          handleKeyDown(_, event) {
            shiftKey = event.shiftKey;
            return false;
          },
          clipboardTextParser(str, $context, _, view) {
            const parser = DOMParser.fromSchema(view.state.schema);
            const doc = document.cloneNode(false);
            const dom = doc.createElement("div");
            if (shiftKey) {
              dom.innerHTML = "<p>" + str.replaceAll("\n", "<br />").replaceAll("<br /><br />", "</p><p>") + "</p>";
            } else {
              dom.innerHTML = markdownit.render(str);
            }
            return parser.parseSlice(dom, { preserveWhitespace: true, context: $context });
          }
        }
      })
    ];
  }
});
/*
 * @copyright Copyright (c) 2019 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const PlainTextDocument = Node.create({
  name: "doc",
  content: "block",
  addKeyboardShortcuts() {
    return {
      Tab: () => this.editor.commands.insertContent("	")
    };
  }
});
/*
 * @copyright Copyright (c) 2022 Max <max@nextcloud.com>
 *
 * @author Max <max@nextcloud.com>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
*/
Extension.create({
  name: "PlainText",
  addExtensions() {
    return [
      PlainTextDocument,
      Text
    ];
  }
});
/*
 * @copyright Copyright (c) 2021 Jonas Meurer <jonas@freesources.org>
 *
 * @author Jonas Meurer <jonas@freesources.org>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
function listInputRule(find, type, getAttributes) {
  const handler = ({ state, range, match }) => {
    const wrap = wrappingInputRule({ find, type, getAttributes });
    wrap.handler({ state, range, match });
    if (match.length >= 3) {
      state.tr.insertText(match[2]);
    }
  };
  return new InputRule({ find, handler });
}
/*
 * @copyright Copyright (c) 2020 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const BulletList = TiptapBulletList.extend({
  parseHTML() {
    return this.parent().map((rule) => Object.assign(rule, { preserveWhitespace: true }));
  },
  addAttributes() {
    var _a2;
    return {
      ...(_a2 = this.parent) == null ? void 0 : _a2.call(this),
      bullet: {
        default: "-",
        rendered: false,
        isRequired: true,
        parseHTML: (el) => el.getAttribute("data-bullet")
      }
    };
  },
  addInputRules() {
    return [
      listInputRule(
        /^\s*([-+*])\s([^\s[]+)$/,
        this.type
      )
    ];
  }
});
const Callout_vue_vue_type_style_index_0_scoped_888f3688_lang = "";
const ICONS_MAP = {
  info: Info,
  success: Positive,
  error: Danger,
  warn: Warn
};
const _sfc_main$d = {
  // eslint-disable-next-line vue/match-component-file-name
  name: "Callout",
  components: {
    NodeViewWrapper,
    NodeViewContent
  },
  props: {
    node: {
      type: Object,
      required: true
    }
  },
  computed: {
    icon() {
      return ICONS_MAP[this.type] || Info;
    },
    type() {
      var _a2, _b2;
      return ((_b2 = (_a2 = this.node) == null ? void 0 : _a2.attrs) == null ? void 0 : _b2.type) || "info";
    }
  }
};
var _sfc_render$d = function render4() {
  var _vm = this, _c = _vm._self._c;
  return _c("NodeViewWrapper", { staticClass: "callout", class: `callout--${_vm.type}`, attrs: { "data-text-el": "callout", "as": "div" } }, [_c(_vm.icon, { tag: "component", staticClass: "callout__icon" }), _c("NodeViewContent", { staticClass: "callout__content" })], 1);
};
var _sfc_staticRenderFns$d = [];
var __component__$d = /* @__PURE__ */ normalizeComponent(
  _sfc_main$d,
  _sfc_render$d,
  _sfc_staticRenderFns$d,
  false,
  null,
  "888f3688",
  null,
  null
);
const Callout$1 = __component__$d.exports;
/*
 * @copyright Copyright (c) 2022 Vinicius Reis <vinicius@nextcloud.com>
 *
 * @author Vinicius Reis <vinicius@nextcloud.com>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const Callout = Node.create({
  name: "callout",
  content: "paragraph+",
  group: "block",
  defining: true,
  addOptions() {
    return {
      types: typesAvailable,
      HTMLAttributes: {
        class: "callout"
      }
    };
  },
  addAttributes() {
    return {
      type: {
        default: "info",
        rendered: false,
        parseHTML: (element) => {
          return element.getAttribute("data-callout") || typesAvailable.find((type) => element.classList.contains(type)) || element.classList.contains("warning") && "warn";
        },
        renderHTML: (attributes) => {
          return {
            "data-callout": attributes.type,
            class: `callout-${attributes.type}`
          };
        }
      }
    };
  },
  parseHTML() {
    return [
      {
        tag: "div.callout"
      },
      {
        tag: "p.callout",
        priority: 1001
      }
    ];
  },
  renderHTML({ node, HTMLAttributes }) {
    const { class: classy } = this.options.HTMLAttributes;
    const attributes = {
      ...this.options.HTMLAttributes,
      "data-callout": node.attrs.type,
      class: `${classy} ${classy}-${node.attrs.type}`
    };
    return ["div", mergeAttributes(attributes, HTMLAttributes), 0];
  },
  toMarkdown: (state, node) => {
    state.write("::: " + (node.attrs.type || "info") + "\n");
    state.renderContent(node);
    state.ensureNewLine();
    state.write(":::");
    state.closeBlock(node);
  },
  addNodeView() {
    return VueNodeViewRenderer(Callout$1);
  },
  addCommands() {
    return {
      setCallout: (attributes) => ({ commands }) => {
        return commands.wrapIn(this.name, attributes);
      },
      toggleCallout: (attributes) => ({ commands, state }) => {
        if (!isNodeActive(state, this.name)) {
          return commands.setCallout(attributes);
        }
        if (!isNodeActive(state, this.name, attributes)) {
          return commands.updateAttributes(this.name, attributes);
        }
        return commands.unsetCallout();
      },
      unsetCallout: () => ({ commands }) => {
        return commands.lift(this.name);
      }
    };
  }
});
const CodeBlock = TiptapCodeBlock.extend({
  parseHTML() {
    return [
      {
        tag: "pre",
        preserveWhitespace: "full",
        // Remove trailing newline from code blocks (#2344)
        getContent: (node, schema) => {
          const textContent = node.textContent.replace(/\n$/, "");
          const inner = textContent ? [schema.text(textContent)] : [];
          return schema.nodes.codeBlock.create(null, inner);
        }
      }
    ];
  },
  toMarkdown(state, node, parent, index) {
    node.attrs.params = node.attrs.language;
    return defaultMarkdownSerializer.nodes.code_block(state, node, parent, index);
  }
});
/*
* @copyright Copyright (c) 2022 Julius Härtl <jus@bitgrid.net>
*
* @author Julius Härtl <jus@bitgrid.net>
*
* @license GNU AGPL version 3 or any later version
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU Affero General Public License as
* published by the Free Software Foundation, either version 3 of the
* License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU Affero General Public License for more details.
*
* You should have received a copy of the GNU Affero General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/
const createSuggestions = ({
  listComponent,
  items = () => {
  },
  command = ({ editor, range, props }) => {
  }
}) => ({
  items,
  command,
  render: () => {
    let component;
    let popup;
    return {
      onStart: (props) => {
        component = new VueRenderer(listComponent, {
          parent: globalThis,
          propsData: props
        });
        if (!props.clientRect) {
          return;
        }
        popup = tippy("body", {
          getReferenceClientRect: props.clientRect,
          appendTo: () => document.body,
          content: component.element,
          showOnCreate: true,
          interactive: true,
          trigger: "manual",
          placement: "bottom-start"
        });
        component.ref.$on("select", () => {
          popup.length > 0 && popup[0].hide();
        });
      },
      onUpdate(props) {
        component.updateProps(props);
        if (!props.clientRect || !popup) {
          return;
        }
        popup[0].setProps({
          getReferenceClientRect: props.clientRect
        });
      },
      onKeyDown(props) {
        var _a2, _b2;
        if (!popup) {
          return;
        }
        if (props.event.key === "Escape") {
          popup[0].hide();
          popup[0].destroy();
          component.destroy();
          popup = null;
          return true;
        }
        return (_b2 = (_a2 = component.ref) == null ? void 0 : _a2.onKeyDown) == null ? void 0 : _b2.call(_a2, props);
      },
      onExit() {
        if (!popup) {
          return;
        }
        popup[0].destroy();
        component.destroy();
      }
    };
  }
});
const EmojiList_vue_vue_type_style_index_0_scoped_d923131c_lang = "";
const _sfc_main$c = {
  name: "EmojiList",
  props: {
    items: {
      type: Array,
      required: true
    },
    command: {
      type: Function,
      required: true
    }
  },
  data() {
    return {
      selectedIndex: 0
    };
  },
  computed: {
    hasResults() {
      return this.items.length > 0;
    },
    itemHeight() {
      return this.$el.scrollHeight / this.items.length;
    },
    itemInsideScrollView() {
      return this.selectedIndex * this.itemHeight >= this.$el.scrollTop && (this.selectedIndex + 1) * this.itemHeight <= this.$el.scrollTop + this.$el.clientHeight;
    }
  },
  watch: {
    items() {
      this.selectedIndex = 0;
      this.$el.scrollTop = 0;
    }
  },
  methods: {
    t: translate,
    onKeyDown({ event }) {
      if (event.ctrlKey || event.shiftKey || event.altKey || event.metaKey) {
        return false;
      }
      if (event.key === "ArrowUp") {
        this.selectedIndex = (this.selectedIndex + this.items.length - 1) % this.items.length;
        if (!this.itemInsideScrollView) {
          this.$el.scrollTop = this.selectedIndex * this.itemHeight;
        }
        return true;
      }
      if (event.key === "ArrowDown") {
        this.selectedIndex = (this.selectedIndex + 1) % this.items.length;
        if (!this.itemInsideScrollView) {
          this.$el.scrollTop = (this.selectedIndex + 1) * this.itemHeight - this.$el.clientHeight;
        }
        return true;
      }
      if (event.key === "Enter" || event.key === "Tab") {
        this.selectItem(this.selectedIndex);
        return true;
      }
      return false;
    },
    selectItem(index) {
      const emojiObject = this.items[index];
      if (emojiObject) {
        this.command(emojiObject);
        emojiAddRecent(emojiObject);
      }
    }
  }
};
var _sfc_render$c = function render5() {
  var _vm = this, _c = _vm._self._c;
  return _c("div", { staticClass: "emoji-list" }, [_vm.hasResults ? _vm._l(_vm.items, function(emojiObject, index) {
    return _c("div", { key: index, staticClass: "emoji-list__item", class: { "is-selected": index === _vm.selectedIndex }, on: { "click": function($event) {
      return _vm.selectItem(index);
    } } }, [_c("span", { staticClass: "emoji-list__item__emoji" }, [_vm._v(" " + _vm._s(emojiObject.native) + " ")]), _vm._v(" :" + _vm._s(emojiObject.short_name) + " ")]);
  }) : _c("div", { staticClass: "emoji-list__item is-empty" }, [_vm._v(" " + _vm._s(_vm.t("text", "No emoji found")) + " ")])], 2);
};
var _sfc_staticRenderFns$c = [];
var __component__$c = /* @__PURE__ */ normalizeComponent(
  _sfc_main$c,
  _sfc_render$c,
  _sfc_staticRenderFns$c,
  false,
  null,
  "d923131c",
  null,
  null
);
const EmojiList = __component__$c.exports;
/*
 * @copyright Copyright (c) 2022 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
const EmojiSuggestion = () => createSuggestions({
  listComponent: EmojiList,
  items: ({ query }) => {
    return emojiSearch(query);
  },
  command: ({ editor, range, props }) => {
    editor.chain().focus().insertContentAt(range, props.native + " ").run();
  }
});
const FrontMatter = TiptapCodeBlock.extend({
  name: "frontMatter",
  // FrontMatter are only valid at the begin of a document
  draggable: false,
  renderHTML({ node, HTMLAttributes }) {
    return this.parent({
      node,
      HTMLAttributes: mergeAttributes(HTMLAttributes, { "data-title": t("text", "Front matter"), class: "frontmatter" })
    });
  },
  parseHTML() {
    return [{
      tag: "pre#frontmatter",
      preserveWhitespace: "full",
      priority: 9001,
      attrs: {
        language: "yaml"
      }
    }];
  },
  toMarkdown: (state, node) => {
    if (!state.out.match(/^\s*/))
      throw Error("FrontMatter must be the first node of the document!");
    const text = node.textContent;
    const dashes = text.match(/-{3,}/gm);
    const separator = dashes ? dashes.sort().slice(-1)[0] + "-" : "---";
    state.write("");
    state.out = "";
    state.write(`${separator}
`);
    state.text(text, false);
    state.ensureNewLine();
    state.write(separator);
    state.closeBlock(node);
  },
  // Allow users to add a FrontMatter, but only at the beginning of the document
  addInputRules() {
    return [
      {
        find: /^---$/g,
        handler: ({ state, range, chain }) => {
          if (range.from === 1) {
            if (state.doc.resolve(1).parent.type.name === this.name)
              return false;
            chain().deleteRange(range).insertContentAt(0, {
              type: this.name
            });
            return true;
          }
          return false;
        }
      }
    ];
  },
  // Override rules from Codeblock
  addCommands() {
    return {};
  },
  addPasteRules: () => [],
  addProseMirrorPlugins: () => []
});
const ParagraphView_vue_vue_type_style_index_0_scoped_88f11b5d_lang = "";
const _sfc_main$b = {
  name: "ParagraphView",
  components: {
    NodeViewWrapper,
    NodeViewContent,
    NcReferenceList
  },
  props: nodeViewProps,
  data() {
    return {
      text: null,
      isLoggedIn: getCurrentUser()
    };
  },
  watch: {
    node: {
      handler(newNode) {
        if (!(newNode == null ? void 0 : newNode.textContent)) {
          this.text = "";
          return;
        }
        this.debouncedUpdateText(newNode);
      }
    }
  },
  beforeCreate() {
    this.debouncedUpdateText = debounce((newNode) => {
      this.text = this.getTextReference(this.node);
    }, 500);
  },
  created() {
    this.text = this.getTextReference(this.node);
  },
  beforeUnmount() {
    var _a2;
    (_a2 = this.debouncedUpdateText) == null ? void 0 : _a2.cancel();
  },
  methods: {
    getTextReference(node) {
      var _a2;
      if (!(node == null ? void 0 : node.childCount)) {
        return null;
      }
      let textNode;
      for (let i = 0; i < node.childCount; i++) {
        const childNode = node.child(i);
        if (childNode.type.name !== "text") {
          return null;
        }
        if (!childNode.textContent.trim()) {
          continue;
        }
        if (textNode) {
          return null;
        }
        textNode = childNode;
      }
      const linkMark = textNode == null ? void 0 : textNode.marks.find((m) => m.type.name === "link");
      const href = (_a2 = linkMark == null ? void 0 : linkMark.attrs) == null ? void 0 : _a2.href;
      const PATTERN = /(^)(https?:\/\/)((?:[-A-Z0-9+_]+\.)+[-A-Z]+(?:\/[-A-Z0-9+&@#%?=~_|!:,.;()]*)*)($)/ig;
      if (new RegExp(PATTERN).test(href)) {
        return href;
      }
      return null;
    }
  }
};
var _sfc_render$b = function render6() {
  var _vm = this, _c = _vm._self._c;
  return _c("NodeViewWrapper", { staticClass: "vue-component", attrs: { "as": "p" } }, [_c("NodeViewContent", { staticClass: "paragraph-content" }), _vm.isLoggedIn && _vm.text ? _c("NcReferenceList", { attrs: { "text": _vm.text, "limit": 1, "contenteditable": "false" } }) : _vm._e()], 1);
};
var _sfc_staticRenderFns$b = [];
var __component__$b = /* @__PURE__ */ normalizeComponent(
  _sfc_main$b,
  _sfc_render$b,
  _sfc_staticRenderFns$b,
  false,
  null,
  "88f11b5d",
  null,
  null
);
const ParagraphView = __component__$b.exports;
const Paragraph = TiptapParagraph.extend({
  addNodeView() {
    return VueNodeViewRenderer(ParagraphView);
  },
  parseHTML() {
    return this.parent().map((rule) => Object.assign(rule, { preserveWhitespace: "full" }));
  },
  addKeyboardShortcuts() {
    return {
      Backspace: () => {
        const selection = this.editor.state.selection;
        if (selection.$from.parentOffset !== 0)
          return false;
        const node = selection.$from.parent;
        const index = selection.$from.index(selection.$from.depth - 1);
        if (index === 0)
          return false;
        const parent = selection.$from.node(selection.$from.depth - 1);
        const previousNode = parent.child(index - 1);
        if (node.type.name === this.name && previousNode.type.name === this.name) {
          return this.editor.chain().joinBackward().setHardBreak().run();
        }
        return false;
      }
    };
  }
});
/*
 * @copyright Copyright (c) 2022 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
*/
const HardBreak = TipTapHardBreak.extend({
  addAttributes() {
    return {
      syntax: {
        default: "  ",
        rendered: false,
        keepOnSplit: true,
        parseHTML: (el) => el.getAttribute("data-syntax") || "  "
      }
    };
  },
  addCommands() {
    return {
      ...this == null ? void 0 : this.parent(),
      setHardBreak: () => (ctx) => {
        for (let d = ctx.state.selection.$from.depth; d >= 0; d--) {
          if (ctx.state.selection.$from.node(d).type.name === "heading")
            return false;
        }
        return this.parent().setHardBreak()(ctx);
      }
    };
  },
  toMarkdown(state, node, parent, index) {
    var _a2;
    for (let i = index + 1; i < parent.childCount; i++) {
      if (parent.child(i).type !== node.type) {
        if (node.attrs.syntax !== "html") {
          state.write(node.attrs.syntax);
          if (!((_a2 = parent.child(i).text) == null ? void 0 : _a2.startsWith("\n")))
            state.write("\n");
        } else {
          state.write("<br />");
        }
        return;
      }
    }
  }
});
const setHeadings = (val) => store$1.dispatch("text/setHeadings", val);
const extractHeadings = (editor) => {
  const counter = /* @__PURE__ */ new Map();
  const headings = [];
  const tr = editor.state.tr;
  const getId = (text) => {
    const id = slugify(text);
    if (counter.has(id)) {
      const next = counter.get(id);
      counter.set(id, next + 1);
      return `h-${id}--${next}`;
    }
    counter.set(id, 1);
    return "h-" + id;
  };
  editor.state.doc.descendants((node, position) => {
    if (node.type.name === "heading") {
      const text = node.textContent;
      const id = getId(text);
      const uuid = node.attrs.uuid ?? v4();
      if (node.attrs.id !== id || !node.attrs.uuid) {
        const attrs = {
          ...node.attrs,
          uuid,
          id
        };
        tr.setNodeMarkup(position, void 0, attrs);
      }
      headings.push(Object.freeze({
        level: node.attrs.level,
        position,
        text,
        id,
        uuid
      }));
    }
  });
  tr.setMeta("addToHistory", false);
  tr.setMeta("preventUpdate", true);
  editor.view.dispatch(tr);
  setHeadings(headings);
};
const HeadingView_vue_vue_type_style_index_0_lang = "";
const _sfc_main$a = Vue.extend({
  name: "HeadingView",
  components: {
    NodeViewWrapper,
    NodeViewContent
  },
  mixins: [useEditorMixin],
  props: {
    node: {
      type: Object,
      required: true
    },
    extension: {
      type: Object,
      required: true
    }
  },
  data() {
    return {
      content: null
    };
  },
  computed: {
    href() {
      return `#${this.node.attrs.id}`;
    },
    domElement() {
      const hasLevel = this.extension.options.levels.includes(this.node.attrs.level);
      const level = hasLevel ? this.node.attrs.level : this.extension.options.levels[0];
      return `h${level}`;
    },
    linkSymbol() {
      return this.extension.options.linkSymbol;
    },
    t: () => window.t
  },
  methods: {
    click() {
      this.$refs.container.$el.scrollIntoView();
      window.location.hash = this.href;
    }
  }
});
var _sfc_render$a = function render7() {
  var _vm = this, _c = _vm._self._c;
  _vm._self._setupProxy;
  return _c("NodeViewWrapper", { ref: "container", attrs: { "id": _vm.node.attrs.id, "as": _vm.domElement } }, [_c("a", { staticClass: "heading-anchor", attrs: { "aria-hidden": "true", "href": _vm.href, "title": _vm.t("text", "Link to this section"), "contenteditable": false }, on: { "click": function($event) {
    $event.stopPropagation();
    return _vm.click.apply(null, arguments);
  } } }, [_vm._v(_vm._s(_vm.linkSymbol))]), _c("NodeViewContent", { attrs: { "as": "span" } })], 1);
};
var _sfc_staticRenderFns$a = [];
var __component__$a = /* @__PURE__ */ normalizeComponent(
  _sfc_main$a,
  _sfc_render$a,
  _sfc_staticRenderFns$a,
  false,
  null,
  null,
  null,
  null
);
const HeaderViewVue = __component__$a.exports;
const Heading = TipTapHeading.extend({
  addAttributes() {
    return {
      ...this.parent(),
      id: {
        default: void 0,
        rendered: true
      },
      uuid: {
        default: void 0,
        rendered: false
      }
    };
  },
  addOptions() {
    var _a2;
    return {
      ...(_a2 = this.parent) == null ? void 0 : _a2.call(this),
      linkSymbol: "#"
    };
  },
  addKeyboardShortcuts() {
    return this.options.levels.reduce((items, level) => ({
      ...items,
      [`Mod-Shift-${level}`]: () => this.editor.commands.toggleHeading({ level })
    }), {});
  },
  addNodeView() {
    return VueNodeViewRenderer(HeaderViewVue, {
      update: ({ oldNode, newNode, updateProps }) => {
        if (newNode.type.name !== this.name)
          return false;
        if (newNode.attrs !== oldNode.attrs)
          return false;
        updateProps();
        return true;
      }
    });
  },
  onCreate() {
    extractHeadings(this.editor);
    if (this.parent) {
      this.parent();
    }
  },
  onUpdate: debounce(({ editor }) => {
    if (editor.view && editor.state && !editor.isDestroyed) {
      extractHeadings(editor);
    }
  }, 900)
});
const ShowImageModal_vue_vue_type_style_index_0_scoped_9b164d61_lang = "";
const _sfc_main$9 = {
  name: "ShowImageModal",
  components: {
    NcModal
  },
  props: {
    images: {
      type: Array,
      default() {
        return [];
      },
      validator(imagesList) {
        return imagesList.length === 0 ? true : imagesList.every((image) => image.basename && image.source);
      }
    },
    startIndex: {
      type: Number,
      default: 0
    },
    show: {
      type: Boolean,
      default: false
    }
  },
  data() {
    return {
      currentImageIndex: 0
    };
  },
  computed: {
    currentImage() {
      return this.images[this.currentImageIndex];
    }
  },
  watch: {
    startIndex(val) {
      this.currentImageIndex = val;
    }
  },
  methods: {
    showNextImage() {
      this.currentImageIndex = (this.currentImageIndex + 1) % this.images.length;
      this.currentImage = this.images[this.currentImageIndex];
    },
    showPreviousImage() {
      this.currentImageIndex = this.currentImageIndex <= 0 ? this.images.length - 1 : this.currentImageIndex - 1;
      this.currentImage = this.images[this.currentImageIndex];
    }
  }
};
var _sfc_render$9 = function render8() {
  var _vm = this, _c = _vm._self._c;
  return _vm.show ? _c("NcModal", { attrs: { "size": "large", "title": _vm.currentImage.basename, "out-transition": true, "has-next": true, "has-previous": true, "close-button-contained": false, "dark": true }, on: { "next": _vm.showNextImage, "previous": _vm.showPreviousImage, "close": function($event) {
    return _vm.$emit("close");
  } } }, [_c("div", { staticClass: "modal__content" }, [_c("img", { attrs: { "src": _vm.currentImage.source } })])]) : _vm._e();
};
var _sfc_staticRenderFns$9 = [];
var __component__$9 = /* @__PURE__ */ normalizeComponent(
  _sfc_main$9,
  _sfc_render$9,
  _sfc_staticRenderFns$9,
  false,
  null,
  "9b164d61",
  null,
  null
);
const ShowImageModal = __component__$9.exports;
/*
 * @copyright Copyright (c) 2019 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const mimetypesImages = [
  "image/png",
  "image/jpeg",
  "image/jpg",
  "image/gif",
  "image/x-xbitmap",
  "image/x-ms-bmp",
  "image/bmp",
  "image/svg+xml",
  "image/webp"
];
if (!((_a = window.oc_appswebroots) == null ? void 0 : _a.richdocuments) && !((_b = window.oc_appswebroots) == null ? void 0 : _b.onlyoffice))
  ;
const ImageView_vue_vue_type_style_index_0_scoped_15de4bb2_lang = "";
const getQueryVariable$1 = (src, variable) => {
  const query = src.split("?")[1];
  if (typeof query === "undefined") {
    return;
  }
  const vars = query.split(/[&#]/);
  if (typeof vars === "undefined") {
    return;
  }
  for (let i = 0; i < vars.length; i++) {
    const pair = vars[i].split("=");
    if (decodeURIComponent(pair[0]) === variable) {
      return decodeURIComponent(pair[1]);
    }
  }
};
class LoadImageError extends Error {
  constructor(reason, imageUrl) {
    super((reason == null ? void 0 : reason.message) || t("text", "Failed to load"));
    this.reason = reason;
    this.imageUrl = imageUrl;
  }
}
const _sfc_main$8 = {
  name: "ImageView",
  components: {
    ImageIcon: Image$2,
    DeleteIcon: Delete,
    NcButton,
    ShowImageModal,
    NodeViewWrapper
  },
  directives: {
    ClickOutside
  },
  mixins: [
    store,
    useAttachmentResolver
  ],
  props: ["editor", "node", "extension", "updateAttributes", "deleteNode"],
  // eslint-disable-line
  data() {
    return {
      imageLoaded: false,
      loaded: false,
      failed: false,
      showIcons: false,
      imageUrl: null,
      errorMessage: null,
      attachmentType: null,
      attachmentMetadata: {},
      showImageModal: false,
      embeddedImagesList: [],
      imageIndex: null
    };
  },
  computed: {
    isMediaAttachment() {
      return this.attachmentType === this.$attachmentResolver.ATTACHMENT_TYPE_MEDIA;
    },
    editable() {
      return this.editor.isEditable;
    },
    showDeleteIcon() {
      return this.editable && this.showIcons;
    },
    showImageDeleteIcon() {
      return this.showDeleteIcon && !this.isMediaAttachment;
    },
    canDisplayImage() {
      if (!this.isSupportedImage) {
        return false;
      }
      if (this.failed && this.loaded) {
        return true;
      }
      return this.loaded && this.imageLoaded;
    },
    imageFileId() {
      return getQueryVariable$1(this.src, "fileId");
    },
    isSupportedImage() {
      return typeof this.mime === "undefined" || mimetypesImages.indexOf(this.mime) !== -1;
    },
    internalLinkOrImage() {
      if (this.imageFileId) {
        return generateUrl("/f/" + this.imageFileId);
      }
      return this.src;
    },
    src: {
      get() {
        return this.node.attrs.src || "";
      },
      set(src) {
        this.updateAttributes({
          src
        });
      }
    },
    alt: {
      get() {
        return this.node.attrs.alt ? this.node.attrs.alt : "";
      },
      set(alt) {
        this.updateAttributes({
          alt
        });
      }
    },
    t() {
      return (a, s) => window.t(a, s);
    },
    token() {
      return document.getElementById("sharingToken") && document.getElementById("sharingToken").value;
    }
  },
  beforeMount() {
    if (!this.isSupportedImage) {
      this.failed = true;
      this.imageLoaded = false;
      this.loaded = true;
      this.errorMessage = t("text", "Unsupported image type");
      return;
    }
    this.init().catch(this.onImageLoadFailure);
  },
  methods: {
    async init() {
      const candidates = await this.$attachmentResolver.resolve(this.src);
      return this.load(candidates);
    },
    async load(candidates) {
      const [candidate, ...fallbacks] = candidates;
      return this.loadImage(candidate.url, candidate.type, candidate.name, candidate.metadata).catch((e) => {
        if (fallbacks.length > 0) {
          return this.load(fallbacks);
        }
        return Promise.reject(e);
      });
    },
    async loadImage(imageUrl, attachmentType, name = null, metadata = null) {
      return new Promise((resolve, reject) => {
        const img = new Image();
        img.onload = async () => {
          this.imageUrl = imageUrl;
          this.imageLoaded = true;
          this.loaded = true;
          this.attachmentType = attachmentType;
          if (attachmentType === this.$attachmentResolver.ATTACHMENT_TYPE_MEDIA && metadata) {
            this.attachmentMetadata = metadata;
          } else if (attachmentType === this.$attachmentResolver.ATTACHMENT_TYPE_MEDIA) {
            await this.loadMediaMetadata(name);
          }
          resolve(imageUrl);
        };
        img.onerror = (e) => {
          reject(new LoadImageError(e, imageUrl));
        };
        img.src = imageUrl;
      });
    },
    loadMediaMetadata(name) {
      const metadataUrl = this.$attachmentResolver.getMediaMetadataUrl(name);
      return axios.get(metadataUrl).then((response) => {
        this.attachmentMetadata = response.data;
      }).catch((error) => {
        logger.error("Failed to load media metadata", { error });
      });
    },
    onImageLoadFailure(err) {
      this.failed = true;
      this.imageLoaded = false;
      this.loaded = true;
      this.errorMessage = err.message;
      if (err instanceof LoadImageError) {
        this.errorMessage = `${this.errorMessage} ${this.src}`;
      }
      this.$emit("error", { error: err, src: this.src });
    },
    updateAlt(event) {
      this.updateAttributes({
        alt: event.target.value
      });
    },
    onLoaded() {
      this.loaded = true;
    },
    async handleImageClick(src) {
      const imageViews = Array.from(document.querySelectorAll('figure[data-component="image-view"].image-view'));
      let basename, relativePath;
      for (const imgv of imageViews) {
        relativePath = imgv.getAttribute("data-src");
        basename = relativePath.split("/").slice(-1).join();
        const response = await this.$attachmentResolver.resolve(relativePath, true);
        const { url: source } = response.shift();
        this.embeddedImagesList.push({
          source,
          basename,
          relativePath
        });
      }
      this.imageIndex = this.embeddedImagesList.findIndex((image) => image.relativePath === src);
      this.showImageModal = true;
    },
    onDelete() {
      emit("text:image-node:delete", this.imageUrl);
      this.deleteNode();
    }
  }
};
var _sfc_render$8 = function render9() {
  var _vm = this, _c = _vm._self._c;
  return _c("NodeViewWrapper", [_c("figure", { staticClass: "image image-view", class: { "icon-loading": !_vm.loaded, "image-view--failed": _vm.failed }, attrs: { "data-component": "image-view", "data-src": _vm.src } }, [_vm.canDisplayImage ? _c("div", { directives: [{ name: "click-outside", rawName: "v-click-outside", value: () => _vm.showIcons = false, expression: "() => showIcons = false" }], staticClass: "image__view", on: { "mouseover": function($event) {
    _vm.showIcons = true;
  }, "mouseleave": function($event) {
    _vm.showIcons = false;
  } } }, [_c("transition", { attrs: { "name": "fade" } }, [!_vm.failed ? [_vm.isMediaAttachment ? _c("div", { staticClass: "media", on: { "click": function($event) {
    return _vm.handleImageClick(_vm.src);
  } } }, [_c("div", { staticClass: "media__wrapper" }, [_c("img", { directives: [{ name: "show", rawName: "v-show", value: _vm.loaded, expression: "loaded" }], staticClass: "image__main", attrs: { "src": _vm.imageUrl }, on: { "load": _vm.onLoaded } }), _c("div", { staticClass: "metadata" }, [_c("span", { staticClass: "name" }, [_vm._v(_vm._s(_vm.alt))]), _c("span", { staticClass: "size" }, [_vm._v(_vm._s(_vm.attachmentMetadata.size))])])]), _vm.showDeleteIcon ? _c("div", { staticClass: "buttons" }, [_c("NcButton", { attrs: { "aria-label": _vm.t("text", "Delete this attachment"), "title": _vm.t("text", "Delete this attachment") }, on: { "click": _vm.onDelete }, scopedSlots: _vm._u([{ key: "icon", fn: function() {
    return [_c("DeleteIcon")];
  }, proxy: true }], null, false, 3930079857) })], 1) : _vm._e()]) : _c("div", [_c("img", { directives: [{ name: "show", rawName: "v-show", value: _vm.loaded, expression: "loaded" }], staticClass: "image__main", attrs: { "src": _vm.imageUrl }, on: { "click": function($event) {
    return _vm.handleImageClick(_vm.src);
  }, "load": _vm.onLoaded } })])] : [_c("ImageIcon", { staticClass: "image__main image__main--broken-icon", attrs: { "size": 100 } })]], 2), _c("transition", { attrs: { "name": "fade" } }, [!_vm.isMediaAttachment ? _c("div", { directives: [{ name: "show", rawName: "v-show", value: _vm.loaded, expression: "loaded" }], staticClass: "image__caption" }, [!_vm.editable ? _c("figcaption", [_vm._v(" " + _vm._s(_vm.alt) + " ")]) : _c("div", { staticClass: "image__caption__wrapper" }, [_c("input", { directives: [{ name: "show", rawName: "v-show", value: !_vm.isMediaAttachment, expression: "!isMediaAttachment" }], ref: "altInput", staticClass: "image__caption__input", attrs: { "type": "text" }, domProps: { "value": _vm.alt }, on: { "blur": _vm.updateAlt, "keyup": function($event) {
    if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "enter", 13, $event.key, "Enter"))
      return null;
    return _vm.updateAlt.apply(null, arguments);
  } } }), _vm.showImageDeleteIcon ? _c("div", { staticClass: "image__caption__delete" }, [_c("NcButton", { attrs: { "aria-label": _vm.t("text", "Delete this image"), "title": _vm.t("text", "Delete this image") }, on: { "click": _vm.onDelete }, scopedSlots: _vm._u([{ key: "icon", fn: function() {
    return [_c("DeleteIcon")];
  }, proxy: true }], null, false, 3930079857) })], 1) : _vm._e()])]) : _vm._e()]), _c("div", { staticClass: "image__modal" }, [_c("ShowImageModal", { attrs: { "images": _vm.embeddedImagesList, "start-index": _vm.imageIndex, "show": _vm.showImageModal }, on: { "close": function($event) {
    _vm.showImageModal = false;
  } } })], 1)], 1) : _c("div", { staticClass: "image-view__cant_display" }, [_c("transition", { attrs: { "name": "fade" } }, [_c("div", { directives: [{ name: "show", rawName: "v-show", value: _vm.loaded, expression: "loaded" }] }, [_c("a", { attrs: { "href": _vm.internalLinkOrImage, "target": "_blank" } }, [!_vm.isSupportedImage ? _c("span", [_vm._v(_vm._s(_vm.alt))]) : _vm._e()])])]), _vm.isSupportedImage ? _c("transition", { attrs: { "name": "fade" } }, [_c("div", { directives: [{ name: "show", rawName: "v-show", value: _vm.loaded, expression: "loaded" }], staticClass: "image__caption" }, [_c("input", { ref: "altInput", attrs: { "type": "text", "disabled": !_vm.editable }, domProps: { "value": _vm.alt }, on: { "blur": _vm.updateAlt, "keyup": function($event) {
    if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "enter", 13, $event.key, "Enter"))
      return null;
    return _vm.updateAlt.apply(null, arguments);
  } } })])]) : _vm._e()], 1), _vm.errorMessage ? _c("small", { staticClass: "image__error-message" }, [_vm._v(" " + _vm._s(_vm.errorMessage) + " ")]) : _vm._e()])]);
};
var _sfc_staticRenderFns$8 = [];
var __component__$8 = /* @__PURE__ */ normalizeComponent(
  _sfc_main$8,
  _sfc_render$8,
  _sfc_staticRenderFns$8,
  false,
  null,
  "15de4bb2",
  null,
  null
);
const ImageView = __component__$8.exports;
/*
 * @copyright Copyright (c) 2019 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const Image$1 = TiptapImage.extend({
  selectable: false,
  parseHTML() {
    return [
      {
        tag: this.options.allowBase64 ? "figure img[src]" : 'figure img[src]:not([src^="data:"])'
      }
    ];
  },
  renderHTML() {
    return ["img"];
  },
  addOptions() {
    var _a2;
    return {
      ...(_a2 = this.parent) == null ? void 0 : _a2.call(this)
    };
  },
  addNodeView() {
    return VueNodeViewRenderer(ImageView);
  },
  addProseMirrorPlugins() {
    return [
      new Plugin({
        props: {
          handleDrop: (view, event, slice) => {
            if (event.dataTransfer.files && event.dataTransfer.files.length > 0) {
              const coordinates = view.posAtCoords({ left: event.clientX, top: event.clientY });
              const customEvent = new CustomEvent("file-drop", {
                bubbles: true,
                detail: {
                  files: event.dataTransfer.files,
                  position: coordinates.pos
                }
              });
              event.target.dispatchEvent(customEvent);
              return true;
            }
          },
          handlePaste: (view, event, slice) => {
            if (event.clipboardData.files && event.clipboardData.files.length > 0) {
              const customEvent = new CustomEvent("image-paste", {
                bubbles: true,
                detail: {
                  files: event.clipboardData.files
                }
              });
              event.target.dispatchEvent(customEvent);
              return true;
            }
          }
        }
      })
    ];
  },
  /* Serializes an image node as a block image, so it ensures an image is always a block by itself */
  toMarkdown(state, node, parent, index) {
    node.attrs.alt = node.attrs.alt.toString();
    defaultMarkdownSerializer.nodes.image(state, node, parent, index);
    state.closeBlock(node);
  }
});
/*
 * @copyright Copyright (c) 2022 Jonas <jonas@freesources.org>
 *
 * @author Jonas <jonas@freesources.org>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const ImageInline = TiptapImage.extend({
  name: "image-inline",
  // Lower priority than (block) Image extension
  priority: 99,
  selectable: false,
  parseHTML() {
    return [
      {
        tag: this.options.allowBase64 ? "img[src]" : 'img[src]:not([src^="data:"])'
      }
    ];
  },
  addOptions() {
    var _a2;
    return {
      ...(_a2 = this.parent) == null ? void 0 : _a2.call(this),
      inline: true
    };
  },
  // Empty commands, we want only those from (block) Image extension
  addCommands() {
    return {};
  },
  // Empty input rules, we want only those from (block) Image extension
  addInputRules() {
    return [];
  },
  addNodeView() {
    return VueNodeViewRenderer(ImageView);
  },
  toMarkdown(state, node, parent, index) {
    return defaultMarkdownSerializer.nodes.image(state, node, parent, index);
  }
});
const KeepSyntax = Mark.create({
  name: "keep-syntax",
  parseHTML() {
    return [
      {
        tag: "span.keep-md"
      }
    ];
  },
  renderHTML() {
    return ["span", { class: "keep-md" }, 0];
  },
  toMarkdown: {
    open: "",
    close: "",
    mixable: true,
    escape: false,
    expelEnclosingWhitespace: true
  },
  /**
   * Remove mark if there were manual changes
   */
  onUpdate() {
    const tr = this.editor.state.tr;
    this.editor.state.doc.descendants((node, pos, parent, index) => {
      if (node.marks.findIndex((mark) => mark.type.name === this.name) !== -1) {
        if (node.type.name !== "text" || node.text.length !== 1) {
          tr.removeMark(pos, pos + node.nodeSize, this.type);
        }
      }
    });
    if (tr.docChanged) {
      tr.setMeta("addToHistory", false);
      tr.setMeta("preventUpdate", true);
      this.editor.view.dispatch(tr);
    }
  }
});
const Mention_vue_vue_type_style_index_0_scoped_94fe9c88_lang = "";
const _sfc_main$7 = {
  name: "Mention",
  components: {
    NcUserBubble,
    NodeViewWrapper
  },
  props: {
    updateAttributes: {
      type: Function,
      required: true
    },
    node: {
      type: Object,
      required: true
    }
  },
  data() {
    return {
      username: this.node.attrs.label
    };
  },
  computed: {
    isCurrentUser() {
      var _a2;
      return this.node.attrs.id === ((_a2 = getCurrentUser()) == null ? void 0 : _a2.uid);
    }
  }
};
var _sfc_render$7 = function render10() {
  var _vm = this, _c = _vm._self._c;
  return _c("NodeViewWrapper", { staticClass: "mention", attrs: { "as": "span", "contenteditable": "false" } }, [_c("NcUserBubble", { staticClass: "mention-user-bubble", attrs: { "user": _vm.node.attrs.id, "display-name": _vm.username, "primary": _vm.isCurrentUser } }, [_vm._v(" @" + _vm._s(_vm.username) + " ")])], 1);
};
var _sfc_staticRenderFns$7 = [];
var __component__$7 = /* @__PURE__ */ normalizeComponent(
  _sfc_main$7,
  _sfc_render$7,
  _sfc_staticRenderFns$7,
  false,
  null,
  "94fe9c88",
  null,
  null
);
const Mention$1 = __component__$7.exports;
const Mention = TipTapMention.extend({
  parseHTML() {
    return [
      {
        tag: 'span[data-type="user"]',
        getAttrs: (element) => {
          return {
            id: element.getAttribute("data-id"),
            label: element.innerText || element.textContent || element.getAttribute("data-label")
          };
        },
        priority: 100
      }
    ];
  },
  renderHTML({ node, HTMLAttributes }) {
    return [
      "span",
      mergeAttributes({ "data-type": "user", class: "mention" }, this.options.HTMLAttributes, HTMLAttributes),
      this.options.renderLabel({
        options: this.options,
        node
      })
    ];
  },
  addNodeView() {
    return VueNodeViewRenderer(Mention$1);
  },
  toMarkdown(state, node) {
    state.write(" ");
    state.write(`@[${node.attrs.label}](mention://user/${node.attrs.id})`);
    state.write(" ");
  }
});
const SuggestionListWrapper_vue_vue_type_style_index_0_scoped_94b18f71_lang = "";
const _sfc_main$6 = {
  name: "SuggestionListWrapper",
  props: {
    items: {
      type: Array,
      required: true
    },
    command: {
      type: Function,
      required: true
    }
  },
  data() {
    return {
      selectedIndex: 0
    };
  },
  computed: {
    hasResults() {
      return this.items.length > 0;
    },
    itemHeight() {
      return this.$el.scrollHeight / this.items.length;
    },
    itemInsideScrollView() {
      return this.selectedIndex * this.itemHeight >= this.$el.scrollTop && (this.selectedIndex + 1) * this.itemHeight <= this.$el.scrollTop + this.$el.clientHeight;
    }
  },
  watch: {
    items() {
      this.selectedIndex = 0;
      this.$el.scrollTop = 0;
    }
  },
  methods: {
    t,
    onKeyDown({ event }) {
      if (event.ctrlKey || event.shiftKey || event.altKey || event.metaKey) {
        return false;
      }
      if (event.key === "ArrowUp") {
        this.selectedIndex = (this.selectedIndex + this.items.length - 1) % this.items.length;
        if (!this.itemInsideScrollView) {
          this.$el.scrollTop = this.selectedIndex * this.itemHeight;
        }
        return true;
      }
      if (event.key === "ArrowDown") {
        this.selectedIndex = (this.selectedIndex + 1) % this.items.length;
        if (!this.itemInsideScrollView) {
          this.$el.scrollTop = (this.selectedIndex + 1) * this.itemHeight - this.$el.clientHeight;
        }
        return true;
      }
      if (event.key === "Enter" || event.key === "Tab") {
        this.selectItem(this.selectedIndex);
        return true;
      }
      return false;
    },
    selectItem(index) {
      const item = this.items[index];
      if (item) {
        this.$emit("select", item);
        this.command(item);
      }
    }
  }
};
var _sfc_render$6 = function render11() {
  var _vm = this, _c = _vm._self._c;
  return _c("div", { staticClass: "suggestion-list" }, [_vm.hasResults ? _vm._l(_vm.items, function(item, index) {
    return _c("div", { key: index, staticClass: "suggestion-list__item", class: { "is-selected": index === _vm.selectedIndex }, on: { "click": function($event) {
      return _vm.selectItem(index);
    } } }, [_vm._t("default", null, { "item": item, "active": index === _vm.selectedIndex })], 2);
  }) : _c("div", { staticClass: "suggestion-list__item is-empty" }, [_vm._v(" " + _vm._s(_vm.t("text", "No suggestion found")) + " ")])], 2);
};
var _sfc_staticRenderFns$6 = [];
var __component__$6 = /* @__PURE__ */ normalizeComponent(
  _sfc_main$6,
  _sfc_render$6,
  _sfc_staticRenderFns$6,
  false,
  null,
  "94b18f71",
  null,
  null
);
const SuggestionListWrapper = __component__$6.exports;
const LinkPickerList_vue_vue_type_style_index_0_scoped_a3373d54_lang = "";
const _sfc_main$5 = {
  components: {
    SuggestionListWrapper
  },
  props: {
    items: {
      type: Array,
      required: true
    },
    command: {
      type: Function,
      required: true
    }
  },
  methods: {
    onKeyDown({ event }) {
      var _a2;
      return (_a2 = this.$refs.suggestionList) == null ? void 0 : _a2.onKeyDown({ event });
    }
  }
};
var _sfc_render$5 = function render12() {
  var _vm = this, _c = _vm._self._c;
  return _c("SuggestionListWrapper", { ref: "suggestionList", attrs: { "command": _vm.command, "items": _vm.items }, on: { "select": (item) => _vm.$emit("select", item) }, scopedSlots: _vm._u([{ key: "default", fn: function({ item }) {
    return [_c("div", { staticClass: "link-picker__item" }, [_c("img", { attrs: { "src": item.icon } }), _c("div", [_vm._v(_vm._s(item.label))])])];
  } }, { key: "empty", fn: function() {
    return [_vm._v(" " + _vm._s(_vm.t("text", "No command found")) + " ")];
  }, proxy: true }]) });
};
var _sfc_staticRenderFns$5 = [];
var __component__$5 = /* @__PURE__ */ normalizeComponent(
  _sfc_main$5,
  _sfc_render$5,
  _sfc_staticRenderFns$5,
  false,
  null,
  "a3373d54",
  null,
  null
);
const LinkPickerList = __component__$5.exports;
/*
 * @copyright Copyright (c) 2022 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
const suggestions = () => createSuggestions({
  listComponent: LinkPickerList,
  command: ({ editor, range, props }) => {
    getLinkWithPicker(props.providerId, true).then((link) => {
      editor.chain().focus().insertContentAt(range, link + " ").run();
    }).catch((error) => {
      console.error("Link picker promise rejected:", error);
    });
  },
  items: ({ query }) => {
    return searchProvider(query).map((p) => {
      return {
        label: p.title,
        icon: p.icon_url,
        providerId: p.id
      };
    });
  }
});
const LinkPickerPluginKey = new PluginKey("linkPicker");
const LinkPicker = Extension.create({
  name: "linkPicker",
  addOptions() {
    return {
      suggestion: {
        char: "/",
        allowedPrefixes: [" "],
        pluginKey: LinkPickerPluginKey,
        ...suggestions()
      }
    };
  },
  addProseMirrorPlugins() {
    return [
      Suggestion$1({
        editor: this.editor,
        ...this.options.suggestion
      })
    ];
  }
});
const TableCaption = Node.create({
  name: "tableCaption",
  content: "inline*",
  addAttributes() {
    return {};
  },
  renderHTML() {
    return ["caption"];
  },
  toMarkdown(state, node) {
  },
  parseHTML() {
    return [
      { tag: "table caption", priority: 90 }
    ];
  }
});
const TableCell = TableCell$1.extend({
  content: "inline*",
  toMarkdown(state, node) {
    var _a2;
    state.write(" ");
    const backup = (_a2 = state.options) == null ? void 0 : _a2.escapeExtraCharacters;
    state.options.escapeExtraCharacters = /\|/;
    state.renderInline(node);
    state.options.escapeExtraCharacters = backup;
    state.write(" |");
  },
  parseHTML() {
    return [
      { tag: "td", preserveWhitespace: true },
      { tag: "th", preserveWhitespace: true },
      { tag: "table thead ~ tbody th", priority: 70, preserveWhitespace: true },
      { tag: "table thead ~ tbody td", priority: 70, preserveWhitespace: true }
    ];
  },
  addAttributes() {
    var _a2;
    return {
      ...(_a2 = this.parent) == null ? void 0 : _a2.call(this),
      textAlign: {
        rendered: false,
        parseHTML: (element) => element.style.textAlign || null
      }
    };
  }
});
const TableHeader = TableHeader$1.extend({
  content: "inline*",
  toMarkdown(state, node) {
    state.write(" ");
    state.renderInline(node);
    state.write(" |");
  },
  parseHTML() {
    return [
      { tag: "table thead:empty ~ tbody :first-child th", priority: 80 },
      { tag: "table thead:empty ~ tbody :first-child td", priority: 80 },
      { tag: "table thead :first-child th", priority: 60 },
      { tag: "table thead :first-child td", priority: 60 },
      { tag: "table tbody :first-child th", priority: 60 },
      { tag: "table tbody :first-child td", priority: 60 },
      { tag: "table > :first-child > th", priority: 60 },
      { tag: "table > :first-child > td", priority: 60 }
    ];
  },
  addAttributes() {
    var _a2;
    return {
      ...(_a2 = this.parent) == null ? void 0 : _a2.call(this),
      textAlign: {
        rendered: false,
        parseHTML: (element) => element.style.textAlign || null
      }
    };
  }
});
const TableRow = TableRow$1.extend({
  content: "tableCell*",
  toMarkdown(state, node) {
    state.write("|");
    state.renderInline(node);
    state.ensureNewLine();
  },
  parseHTML() {
    return [
      { tag: "tr", priority: 80 }
    ];
  }
});
const TableHeadRow = TableRow.extend({
  name: "tableHeadRow",
  content: "tableHeader*",
  toMarkdown(state, node) {
    state.write("|");
    state.renderInline(node);
    state.ensureNewLine();
    state.write("|");
    node.forEach((cell) => {
      var _a2;
      let row = state.repeat("-", cell.textContent.length + 2);
      const align = (_a2 = cell.attrs) == null ? void 0 : _a2.textAlign;
      if (align === "center" || align === "left")
        row = ":" + row.slice(1);
      if (align === "center" || align === "right")
        row = row.slice(0, -1) + ":";
      state.write(row);
      state.write("|");
    });
    state.ensureNewLine();
  },
  parseHTML() {
    return [
      { tag: "tr", priority: 70 }
    ];
  }
});
function createTable(schema, rowsCount, colsCount, cellContent) {
  const headerCells = [];
  const cells = [];
  for (let index = 0; index < colsCount; index += 1) {
    const cell = schema.nodes.tableCell.createAndFill();
    if (cell) {
      cells.push(cell);
    }
    const headerCell = schema.nodes.tableHeader.createAndFill();
    if (headerCell) {
      headerCells.push(headerCell);
    }
  }
  const headRow = schema.nodes.tableHeadRow.createChecked(null, headerCells);
  const rows = [];
  for (let index = 1; index < rowsCount; index += 1) {
    rows.push(schema.nodes.tableRow.createChecked(null, cells));
  }
  return schema.nodes.table.createChecked(null, [headRow, ...rows]);
}
function findSameCellInNextRow($cell) {
  if ($cell.index(-1) === $cell.node(-1).childCount - 1) {
    return null;
  }
  let cellStart = $cell.after();
  const table = $cell.node(-1);
  for (let row = $cell.indexAfter(-1); row < table.childCount; row++) {
    const rowNode = table.child(row);
    if (rowNode.childCount >= $cell.index()) {
      for (let cell = 0; cell < $cell.index(); cell++) {
        const cellNode = rowNode.child(cell);
        cellStart += cellNode.nodeSize;
      }
      return cellStart + 1;
    }
    cellStart += rowNode.nodeSize;
  }
}
const Table = Table$1.extend({
  content: "tableCaption? tableHeadRow tableRow*",
  addExtensions() {
    return [
      TableCaption,
      TableCell,
      TableHeader,
      TableHeadRow,
      TableRow
    ];
  },
  addCommands() {
    return {
      ...this.parent(),
      addRowAfter: () => ({ chain, dispatch }) => {
        return chain().command(({ state }) => addRowAfter(state, dispatch)).command(({ state, tr }) => {
          const { tableStart, table, bottom } = selectedRect(state);
          if (dispatch) {
            const lastRow = table.child(bottom - 1);
            const newRow = table.child(bottom);
            let pos = tableStart + 1;
            for (let i = 0; i < bottom; i++) {
              pos += table.child(i).nodeSize;
            }
            for (let i = 0; i < lastRow.childCount; i++) {
              tr.setNodeAttribute(
                pos,
                "textAlign",
                lastRow.child(i).attrs.textAlign
              );
              pos += newRow.child(i).nodeSize;
            }
          }
          return true;
        }).run();
      },
      addRowBefore: () => ({ chain, dispatch }) => chain().command(({ state }) => addRowBefore(state, dispatch)).command(({ state, tr }) => {
        const { tableStart, table, top } = selectedRect(state);
        if (dispatch) {
          const lastRow = table.child(top);
          const newRow = table.child(top - 1);
          let pos = tableStart + 1;
          for (let i = 0; i < top - 1; i++) {
            pos += table.child(i).nodeSize;
          }
          for (let i = 0; i < lastRow.childCount; i++) {
            tr.setNodeAttribute(
              pos,
              "textAlign",
              lastRow.child(i).attrs.textAlign
            );
            pos += newRow.child(i).nodeSize;
          }
        }
        return true;
      }).run(),
      insertTable: () => ({ tr, dispatch, editor }) => {
        if (isInTable(tr))
          return false;
        const node = createTable(editor.schema, 3, 3);
        if (dispatch) {
          const offset = tr.selection.anchor + 1;
          tr.replaceSelectionWith(node).scrollIntoView().setSelection(TextSelection.near(tr.doc.resolve(offset)));
        }
        return true;
      },
      // move to the next node after the table from the last cell
      leaveTable: () => ({ tr, dispatch, editor }) => {
        if (!isInTable(tr))
          return false;
        const { $head, empty } = tr.selection;
        if (!empty)
          return false;
        const tableDepth = $head.depth < 3 ? 1 : $head.depth - 2;
        if (dispatch) {
          const $next = tr.doc.resolve($head.after(tableDepth) + 1);
          const selection = TextSelection.near($next);
          dispatch(tr.setSelection(selection).scrollIntoView());
        }
        return true;
      },
      goToNextRow: () => ({ tr, dispatch, editor }) => {
        if (!isInTable(tr))
          return false;
        const cell = findSameCellInNextRow(selectionCell(tr));
        if (cell == null)
          return;
        if (dispatch) {
          const $cell = tr.doc.resolve(cell);
          const selection = TextSelection.between($cell, moveCellForward($cell));
          dispatch(tr.setSelection(selection).scrollIntoView());
        }
        return true;
      }
    };
  },
  renderHTML({ HTMLAttributes }) {
    return ["table", mergeAttributes(this.options.HTMLAttributes, HTMLAttributes), 0];
  },
  toMarkdown(state, node) {
    state.renderContent(node);
    state.closeBlock(node);
  },
  addKeyboardShortcuts() {
    return {
      ...this.parent(),
      Tab: () => this.editor.commands.goToNextCell() || this.editor.commands.leaveTable(),
      Enter: ({ editor }) => {
        var _a2;
        const { selection } = editor.state;
        if (!selection.$from.parent.type.name.startsWith("table"))
          return false;
        if (((_a2 = selection.$from.nodeBefore) == null ? void 0 : _a2.type.name) === "hardBreak") {
          if (editor.can().goToNextRow() || editor.can().addRowAfter()) {
            editor.chain().setTextSelection({ from: selection.from - 1, to: selection.from }).deleteSelection().run();
            if (editor.commands.goToNextRow())
              return true;
            return editor.chain().addRowAfter().goToNextRow().run();
          }
          return false;
        } else {
          return editor.chain().insertContent('<br data-syntax="html" />').focus().run();
        }
      }
    };
  }
});
const TableView_vue_vue_type_style_index_0_scoped_d54bf678_lang = "";
const _sfc_main$4 = {
  name: "TableView",
  components: {
    NcActionButton,
    NcActions,
    NodeViewWrapper,
    NodeViewContent,
    TableSettings,
    Delete
  },
  props: {
    editor: {
      type: Object,
      required: true
    },
    deleteNode: {
      type: Function,
      required: true
    }
  },
  computed: {
    t: () => window.t
  }
};
var _sfc_render$4 = function render13() {
  var _vm = this, _c = _vm._self._c;
  return _c("NodeViewWrapper", { staticClass: "table-wrapper", attrs: { "data-text-el": "table-view" } }, [_vm.editor.isEditable ? _c("NcActions", { staticClass: "table-settings", attrs: { "force-menu": "", "data-text-table-actions": "settings" }, scopedSlots: _vm._u([{ key: "icon", fn: function() {
    return [_c("TableSettings")];
  }, proxy: true }], null, false, 1699550424) }, [_c("NcActionButton", { attrs: { "data-text-table-action": "delete", "close-after-click": "" }, on: { "click": _vm.deleteNode }, scopedSlots: _vm._u([{ key: "icon", fn: function() {
    return [_c("Delete")];
  }, proxy: true }], null, false, 3429380666) }, [_vm._v(" " + _vm._s(_vm.t("text", "Delete this table")) + " ")])], 1) : _vm._e(), _c("NodeViewContent", { staticClass: "content", attrs: { "as": "table" } }), _c("div", { staticClass: "clearfix" })], 1);
};
var _sfc_staticRenderFns$4 = [];
var __component__$4 = /* @__PURE__ */ normalizeComponent(
  _sfc_main$4,
  _sfc_render$4,
  _sfc_staticRenderFns$4,
  false,
  null,
  "d54bf678",
  null,
  null
);
const TableView = __component__$4.exports;
const TableCellView_vue_vue_type_style_index_0_scoped_0b5211d2_lang = "";
const _sfc_main$3 = {
  name: "TableCellView",
  components: {
    NcActionButton,
    NcActions,
    NodeViewWrapper,
    NodeViewContent,
    TableAddRowBefore,
    TableAddRowAfter,
    Delete
  },
  props: {
    editor: {
      type: Object,
      required: true
    },
    getPos: {
      type: Function,
      required: true
    }
  },
  computed: {
    t: () => window.t,
    textAlign() {
      return { "text-align": this.node.attrs.textAlign };
    }
  },
  methods: {
    deleteRow() {
      this.editor.chain().focus().setTextSelection(this.getPos()).deleteRow().run();
    },
    addRowBefore() {
      this.editor.chain().focus().setTextSelection(this.getPos()).addRowBefore().run();
    },
    addRowAfter() {
      this.editor.chain().focus().setTextSelection(this.getPos()).addRowAfter().run();
    }
  }
};
var _sfc_render$3 = function render14() {
  var _vm = this, _c = _vm._self._c;
  return _c("NodeViewWrapper", { style: _vm.textAlign, attrs: { "data-text-el": "table-cell", "as": "td" } }, [_c("div", { staticClass: "container" }, [_c("NodeViewContent", { staticClass: "content" }), _vm.editor.isEditable ? _c("NcActions", { attrs: { "data-text-table-actions": "row" } }, [_c("NcActionButton", { attrs: { "data-text-table-action": "add-row-before", "close-after-click": "" }, on: { "click": _vm.addRowBefore }, scopedSlots: _vm._u([{ key: "icon", fn: function() {
    return [_c("TableAddRowBefore")];
  }, proxy: true }], null, false, 1805502767) }, [_vm._v(" " + _vm._s(_vm.t("text", "Add row before")) + " ")]), _c("NcActionButton", { attrs: { "data-text-table-action": "add-row-after", "close-after-click": "" }, on: { "click": _vm.addRowAfter }, scopedSlots: _vm._u([{ key: "icon", fn: function() {
    return [_c("TableAddRowAfter")];
  }, proxy: true }], null, false, 3179199218) }, [_vm._v(" " + _vm._s(_vm.t("text", "Add row after")) + " ")]), _c("NcActionButton", { attrs: { "data-text-table-action": "remove-row", "close-after-click": "" }, on: { "click": _vm.deleteRow }, scopedSlots: _vm._u([{ key: "icon", fn: function() {
    return [_c("Delete")];
  }, proxy: true }], null, false, 3429380666) }, [_vm._v(" " + _vm._s(_vm.t("text", "Delete this row")) + " ")])], 1) : _vm._e()], 1)]);
};
var _sfc_staticRenderFns$3 = [];
var __component__$3 = /* @__PURE__ */ normalizeComponent(
  _sfc_main$3,
  _sfc_render$3,
  _sfc_staticRenderFns$3,
  false,
  null,
  "0b5211d2",
  null,
  null
);
const TableCellView = __component__$3.exports;
const InlineActionsContainer_vue_vue_type_style_index_0_lang = "";
const _sfc_main$2 = defineComponent({
  name: "InlineActionsContainer"
});
var _sfc_render$2 = function render15() {
  var _vm = this, _c = _vm._self._c;
  _vm._self._setupProxy;
  return _c("li", { staticClass: "inline-container-base" }, [_c("ul", { staticClass: "inline-container-content" }, [_vm._t("default")], 2)]);
};
var _sfc_staticRenderFns$2 = [];
var __component__$2 = /* @__PURE__ */ normalizeComponent(
  _sfc_main$2,
  _sfc_render$2,
  _sfc_staticRenderFns$2,
  false,
  null,
  null,
  null,
  null
);
const InlineActionsContainer = __component__$2.exports;
const TableHeaderView_vue_vue_type_style_index_0_scoped_8221f9e6_lang = "";
const _sfc_main$1 = {
  name: "TableHeaderView",
  components: {
    AlignHorizontalCenter,
    AlignHorizontalLeft,
    AlignHorizontalRight,
    Delete,
    InlineActionsContainer,
    NcActionButton,
    NcActions,
    NodeViewWrapper,
    NodeViewContent,
    TableAddColumnBefore,
    TableAddColumnAfter
  },
  props: {
    editor: {
      type: Object,
      required: true
    },
    getPos: {
      type: Function,
      required: true
    },
    node: {
      type: Object,
      required: true
    }
  },
  computed: {
    t: () => window.t,
    textAlign() {
      return { "text-align": this.node.attrs.textAlign };
    }
  },
  methods: {
    alignCenter() {
      this.align("center");
    },
    alignLeft() {
      this.align("left");
    },
    alignRight() {
      this.align("right");
    },
    align(textAlign) {
      this.editor.chain().focus().setTextSelection(this.getPos()).setCellAttribute("textAlign", textAlign).run();
      while (this.editor.commands.goToNextRow()) {
        this.editor.commands.setCellAttribute("textAlign", textAlign);
      }
      this.editor.chain().setTextSelection(this.getPos()).focus().run();
      this.$refs.menu.closeMenu(false);
    },
    deleteColumn() {
      this.editor.chain().focus().setTextSelection(this.getPos()).deleteColumn().run();
    },
    addColumnBefore() {
      this.editor.chain().focus().setTextSelection(this.getPos()).addColumnBefore().run();
    },
    addColumnAfter() {
      this.editor.chain().focus().setTextSelection(this.getPos()).addColumnAfter().run();
    }
  }
};
var _sfc_render$1 = function render16() {
  var _vm = this, _c = _vm._self._c;
  return _c("NodeViewWrapper", { style: _vm.textAlign, attrs: { "data-text-el": "table-header", "as": "th" } }, [_c("div", [_c("NodeViewContent", { staticClass: "content" }), _vm.editor.isEditable ? _c("NcActions", { ref: "menu", attrs: { "data-text-table-actions": "header" } }, [_c("InlineActionsContainer", [_c("NcActionButton", { attrs: { "data-text-table-action": "align-column-left", "aria-label": _vm.t("text", "Left align column") }, on: { "click": _vm.alignLeft }, scopedSlots: _vm._u([{ key: "icon", fn: function() {
    return [_c("AlignHorizontalLeft")];
  }, proxy: true }], null, false, 2968467243) }), _c("NcActionButton", { attrs: { "data-text-table-action": "align-column-center", "aria-label": _vm.t("text", "Center align column") }, on: { "click": _vm.alignCenter }, scopedSlots: _vm._u([{ key: "icon", fn: function() {
    return [_c("AlignHorizontalCenter")];
  }, proxy: true }], null, false, 536750267) }), _c("NcActionButton", { attrs: { "data-text-table-action": "align-column-right", "aria-label": _vm.t("text", "Right align column") }, on: { "click": _vm.alignRight }, scopedSlots: _vm._u([{ key: "icon", fn: function() {
    return [_c("AlignHorizontalRight")];
  }, proxy: true }], null, false, 3861151024) })], 1), _c("NcActionButton", { attrs: { "data-text-table-action": "add-column-before", "close-after-click": "" }, on: { "click": _vm.addColumnBefore }, scopedSlots: _vm._u([{ key: "icon", fn: function() {
    return [_c("TableAddColumnBefore")];
  }, proxy: true }], null, false, 3782681875) }, [_vm._v(" " + _vm._s(_vm.t("text", "Add column before")) + " ")]), _c("NcActionButton", { attrs: { "data-text-table-action": "add-column-after", "close-after-click": "" }, on: { "click": _vm.addColumnAfter }, scopedSlots: _vm._u([{ key: "icon", fn: function() {
    return [_c("TableAddColumnAfter")];
  }, proxy: true }], null, false, 1608287598) }, [_vm._v(" " + _vm._s(_vm.t("text", "Add column after")) + " ")]), _c("NcActionButton", { attrs: { "data-text-table-action": "remove-column", "close-after-click": "" }, on: { "click": _vm.deleteColumn }, scopedSlots: _vm._u([{ key: "icon", fn: function() {
    return [_c("Delete")];
  }, proxy: true }], null, false, 3429380666) }, [_vm._v(" " + _vm._s(_vm.t("text", "Delete this column")) + " ")])], 1) : _vm._e()], 1)]);
};
var _sfc_staticRenderFns$1 = [];
var __component__$1 = /* @__PURE__ */ normalizeComponent(
  _sfc_main$1,
  _sfc_render$1,
  _sfc_staticRenderFns$1,
  false,
  null,
  "8221f9e6",
  null,
  null
);
const TableHeaderView = __component__$1.exports;
function extendNodeWithView(node, view) {
  return node.extend({
    addNodeView() {
      return VueNodeViewRenderer(view);
    }
  });
}
const EditableTable = Table.extend({
  addNodeView() {
    return VueNodeViewRenderer(TableView);
  },
  addExtensions() {
    return [
      TableCaption,
      extendNodeWithView(TableCell, TableCellView),
      extendNodeWithView(TableHeader, TableHeaderView),
      TableHeadRow,
      TableRow
    ];
  }
});
const findParentNodeClosestToPos = ($pos, predicate) => {
  for (let i = $pos.depth; i > 0; i--) {
    const node = $pos.node(i);
    if (predicate(node)) {
      return {
        pos: i > 0 ? $pos.before(i) : 0,
        start: $pos.start(i),
        depth: i,
        node
      };
    }
  }
};
/*
 * @copyright Copyright (c) 2019 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const TaskItem = TipTapTaskItem.extend({
  addOptions() {
    return {
      nested: true,
      HTMLAttributes: {}
    };
  },
  draggable: false,
  content: "paragraph block*",
  addAttributes() {
    const adjust = { ...this.parent() };
    adjust.checked.parseHTML = (el) => {
      var _a2;
      return (_a2 = el.querySelector("input[type=checkbox]")) == null ? void 0 : _a2.checked;
    };
    return adjust;
  },
  parseHTML: [
    {
      priority: 101,
      tag: "li",
      getAttrs: (el) => {
        const checkbox = el.querySelector("input[type=checkbox]");
        return checkbox;
      },
      context: "taskList/"
    }
  ],
  renderHTML({ node, HTMLAttributes }) {
    const listAttributes = { class: "checkbox-item" };
    const checkboxAttributes = { type: "checkbox", class: "", contenteditable: false };
    if (node.attrs.checked) {
      checkboxAttributes.checked = true;
      listAttributes.class += " checked";
    }
    return [
      "li",
      mergeAttributes(HTMLAttributes, listAttributes),
      [
        "input",
        checkboxAttributes
      ],
      [
        "label",
        0
      ]
    ];
  },
  // overwrite the parent node view so renderHTML gets used
  addNodeView: false,
  toMarkdown: (state, node) => {
    state.write(`[${node.attrs.checked ? "x" : " "}] `);
    state.renderContent(node);
  },
  addInputRules() {
    return [
      ...this.parent(),
      wrappingInputRule({
        find: /^\s*([-+*])\s(\[(x|X|\s)?\])\s$/,
        type: this.type,
        getAttributes: (match) => ({
          checked: "xX".includes(match[match.length - 1])
        })
      })
    ];
  },
  addProseMirrorPlugins() {
    return [
      new Plugin({
        props: {
          handleClick: (view, pos, event) => {
            const state = view.state;
            const schema = state.schema;
            const coordinates = view.posAtCoords({ left: event.clientX, top: event.clientY });
            const position = state.doc.resolve(coordinates.pos);
            const parentList = findParentNodeClosestToPos(position, function(node) {
              return node.type === schema.nodes.taskItem || node.type === schema.nodes.listItem;
            });
            const isListClicked = event.target.tagName.toLowerCase() === "li";
            if (!isListClicked || !parentList || parentList.node.type !== schema.nodes.taskItem || !view.editable) {
              return;
            }
            const tr = state.tr;
            tr.setNodeMarkup(parentList.pos, schema.nodes.taskItem, { checked: !parentList.node.attrs.checked });
            view.dispatch(tr);
          }
        }
      })
    ];
  }
});
/*
 * @copyright Copyright (c) 2020 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const TaskList = TiptapTaskList.extend({
  parseHTML: [
    {
      priority: 100,
      tag: "ul.contains-task-list"
    }
  ],
  addAttributes() {
    var _a2;
    return {
      ...(_a2 = this.parent) == null ? void 0 : _a2.call(this),
      bullet: {
        default: "-",
        rendered: false,
        isRequired: true,
        parseHTML: (el) => el.getAttribute("data-bullet")
      }
    };
  },
  toMarkdown: (state, node) => {
    state.renderList(node, "  ", () => `${node.attrs.bullet} `);
  }
});
/*
 * @copyright Copyright (c) 2021, überdosis GbR
 *
 * @license MIT
 *
 */
function nodeEqualsType({ types, node }) {
  return Array.isArray(types) && types.includes(node.type) || node.type === types;
}
const TrailingNode = Extension.create({
  name: "trailingNode",
  addOptions() {
    return {
      node: "paragraph",
      notAfter: ["paragraph"]
    };
  },
  addProseMirrorPlugins() {
    const plugin2 = new PluginKey(this.name);
    const disabledNodes = Object.entries(this.editor.schema.nodes).map(([, value]) => value).filter((node) => this.options.notAfter.includes(node.name));
    return [
      new Plugin({
        key: plugin2,
        appendTransaction: (_, __, state) => {
          const { doc, tr, schema } = state;
          const shouldInsertNodeAtEnd = plugin2.getState(state);
          const endPosition = doc.content.size;
          const type = schema.nodes[this.options.node];
          if (!shouldInsertNodeAtEnd) {
            return;
          }
          return tr.insert(endPosition, type.create());
        },
        state: {
          init: (_, state) => {
            const lastNode = state.tr.doc.lastChild;
            return !nodeEqualsType({ node: lastNode, types: disabledNodes });
          },
          apply: (tr, value) => {
            if (!tr.docChanged) {
              return value;
            }
            const lastNode = tr.doc.lastChild;
            return !nodeEqualsType({ node: lastNode, types: disabledNodes });
          }
        }
      })
    ];
  }
});
/**
 * @copyright Copyright (c) 2020 Azul <azul@riseup.net>
 *
 * @author Azul <azul@riseup.net>
 *
 * @license AGPL-3.0-or-later
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const absolutePath = function(base, rel) {
  if (!rel) {
    return base;
  }
  if (rel[0] === "/") {
    return rel;
  }
  base = base.split("/");
  rel = rel.split("/");
  while (rel[0] === ".." || rel[0] === ".") {
    if (rel[0] === "..") {
      base.pop();
    }
    rel.shift();
  }
  return base.concat(rel).join("/");
};
const basedir = function(file) {
  const end = file.lastIndexOf("/");
  return end > 0 ? file.slice(0, end) : file.slice(0, end + 1);
};
const domHref = function(node, relativePath) {
  var _a2;
  const ref = node.attrs.href;
  if (!ref) {
    return ref;
  }
  if (!OCA.Viewer) {
    return ref;
  }
  if (ref.match(/^[a-zA-Z]*:/)) {
    return ref;
  }
  if (ref.startsWith("#")) {
    return ref;
  }
  const match = ref.match(/^([^?]*)\?fileId=(\d+)/);
  if (match) {
    const [, relPath, id] = match;
    const currentDir = basedir(relativePath || ((_a2 = OCA.Viewer) == null ? void 0 : _a2.file) || "/");
    const dir = absolutePath(currentDir, basedir(relPath));
    if (relPath.length > 1 && relPath.endsWith("/")) {
      return generateUrl(`/apps/files/?dir=${dir}&fileId=${id}`);
    } else {
      return generateUrl(`/apps/files/?dir=${dir}&openfile=${id}#relPath=${relPath}`);
    }
  }
  return ref;
};
const parseHref = function(dom) {
  const ref = dom.getAttribute("href");
  if (!ref) {
    return ref;
  }
  const match = ref.match(/\?dir=([^&]*)&openfile=([^&]*)#relPath=([^&]*)/);
  if (match) {
    const [, , id, path] = match;
    return `${path}?fileId=${id}`;
  }
  return ref;
};
const openLink = function(event, _attrs) {
  const linkElement = event.target.closest("a");
  const htmlHref = linkElement.href;
  const query = OC.parseQueryString(htmlHref);
  const fragment = htmlHref.split("#").pop();
  const fragmentQuery = OC.parseQueryString(fragment);
  if ((query == null ? void 0 : query.dir) && (fragmentQuery == null ? void 0 : fragmentQuery.relPath)) {
    const filename = fragmentQuery.relPath.split("/").pop();
    const path = `${query.dir}/${filename}`;
    document.title = `${filename} - ${OC.theme.title}`;
    if (window.location.pathname.match(/apps\/files\/$/))
      ;
    OCA.Viewer.open({ path });
    return;
  }
  if (htmlHref.match(/apps\/files\//) && (query == null ? void 0 : query.fileId)) {
    window.open(generateUrl(`/f/${query.fileId}`), "_self");
    return;
  }
  if (!markdownit.validateLink(htmlHref)) {
    logger.error("Invalid link", { htmlHref });
    return false;
  }
  if (fragment) {
    const el = document.getElementById(fragment);
    if (el) {
      el.scrollIntoView();
      window.location.hash = fragment;
      return;
    }
  }
  window.open(htmlHref);
  return true;
};
const clickHandler = ({ editor, type, onClick }) => {
  return new Plugin({
    props: {
      key: new PluginKey("textLink"),
      handleClick: (view, pos, event) => {
        const $clicked = view.state.doc.resolve(pos);
        const link = $clicked.marks().find((m) => m.type.name === type.name);
        if (!link) {
          return false;
        }
        if (!link.attrs.href) {
          logger.warn("Could not determine href of link.");
          logger.debug("Link", { link });
          return false;
        }
        if (event.button === 0 && !event.ctrlKey) {
          event.stopPropagation();
          return onClick == null ? void 0 : onClick(event, link.attrs);
        }
      }
    }
  });
};
const clickPreventer = () => {
  return new Plugin({
    props: {
      key: new PluginKey("textAvoidLinkClick"),
      handleDOMEvents: {
        click: (view, event) => {
          if (!view.editable) {
            event.preventDefault();
            return false;
          }
        }
      }
    }
  });
};
/*
 * @copyright Copyright (c) 2019 Azul <azul@riseup.net>
 *
 * @author Azul <azul@riseup.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const Link = TipTapLink.extend({
  addOptions() {
    var _a2;
    return {
      ...(_a2 = this.parent) == null ? void 0 : _a2.call(this),
      onClick: openLink,
      relativePath: null
    };
  },
  addAttributes() {
    return {
      href: {
        default: null
      },
      title: {
        default: null
      }
    };
  },
  inclusive: false,
  parseHTML: [
    {
      tag: "a[href]",
      getAttrs: (dom) => ({
        href: parseHref(dom),
        title: dom.getAttribute("title")
      })
    }
  ],
  renderHTML(options) {
    const { mark } = options;
    return ["a", {
      ...mark.attrs,
      href: domHref(mark, this.options.relativePath),
      rel: "noopener noreferrer nofollow"
    }, 0];
  },
  addProseMirrorPlugins() {
    const plugins = this.parent().filter(({ key }) => {
      return !key.startsWith("handleClickLink");
    });
    if (!this.options.openOnClick) {
      return plugins;
    }
    return [
      ...plugins,
      clickHandler({
        editor: this.editor,
        type: this.type,
        onClick: this.options.onClick
      }),
      clickPreventer()
    ];
  }
});
/*
 * @copyright Copyright (c) 2019 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const Strike = TipTapStrike.extend({
  parseHTML() {
    return [
      {
        tag: "s"
      },
      {
        tag: "del"
      },
      {
        tag: "strike"
      },
      {
        style: "text-decoration",
        getAttrs: (value) => value === "line-through"
      }
    ];
  },
  renderHTML() {
    return ["s", 0];
  },
  /** Strike is currently unsupported by prosemirror-markdown */
  toMarkdown: {
    open: "~~",
    close: "~~",
    mixable: true,
    expelEnclosingWhitespace: true
  }
});
/*
 * @copyright Copyright (c) 2019 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const Strong = Bold.extend({
  name: "strong",
  addInputRules() {
    return [
      markInputRule({
        find: starInputRegex,
        type: this.type
      })
    ];
  },
  addPasteRules() {
    return [
      markPasteRule({
        find: starPasteRegex,
        type: this.type
      })
    ];
  }
});
/*
 * @copyright Copyright (c) 2022 Max <max@nextcloud.com>
 *
 * @author Max <max@nextcloud.com>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const Underline = TipTapUnderline.extend({
  parseHTML() {
    return [
      {
        tag: "u"
      },
      {
        style: "text-decoration",
        getAttrs: (value) => value === "underline"
      }
    ];
  },
  renderHTML() {
    return ["u", 0];
  },
  toMarkdown: {
    open: "__",
    close: "__",
    mixable: true,
    expelEnclosingWhitespace: true
  },
  addInputRules() {
    return [
      markInputRule({
        find: underscoreInputRegex,
        type: this.type
      })
    ];
  },
  addPasteRules() {
    return [
      markPasteRule({
        find: underscorePasteRegex,
        type: this.type
      })
    ];
  }
});
/*
 * @copyright Copyright (c) 2019 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const Italic = TipTapItalic.extend({
  name: "em"
});
/**
 * @copyright Copyright (c) 2022 Max <max@nextcloud.com>
 *
 * @author Max <max@nextcloud.com>
 *
 * @license AGPL-3.0-or-later
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const RichText = Extension.create({
  name: "RichText",
  addOptions() {
    return {
      editing: true,
      link: {},
      extensions: [],
      component: null,
      relativePath: null
    };
  },
  addExtensions() {
    const defaultExtensions = [
      this.options.editing ? Markdown : null,
      Document,
      Text,
      Paragraph,
      HardBreak,
      Heading,
      Strong,
      Italic,
      Strike,
      Blockquote,
      CharacterCount,
      Code,
      CodeBlock,
      BulletList,
      HorizontalRule,
      OrderedList,
      ListItem,
      this.options.editing ? EditableTable : Table,
      TaskList,
      TaskItem,
      Callout,
      Underline,
      Image$1,
      ImageInline,
      Dropcursor,
      KeepSyntax,
      FrontMatter,
      Mention,
      History,
      Emoji.configure({
        suggestion: EmojiSuggestion()
      }),
      LinkPicker,
      this.options.editing ? Placeholder.configure({
        emptyNodeClass: "is-empty",
        placeholder: translate("text", "Add notes, lists or links …"),
        showOnlyWhenEditable: true
      }) : null,
      TrailingNode
    ];
    if (this.options.link !== false) {
      defaultExtensions.push(Link.configure({
        ...this.options.link,
        openOnClick: true,
        validate: (href) => /^https?:\/\//.test(href),
        relativePath: this.options.relativePath
      }));
    }
    const additionalExtensionNames = this.options.extensions.map((e) => e.name);
    return [
      ...defaultExtensions.filter((e) => e && !additionalExtensionNames.includes(e.name)),
      ...this.options.extensions
    ];
  }
});
const RichTextReader_vue_vue_type_style_index_0_lang = "";
const _sfc_main = {
  name: "RichTextReader",
  components: { BaseReader },
  provide: {
    renderHtml(content) {
      return markdownit.render(content);
    },
    extensions() {
      return [
        RichText.configure({
          editing: false,
          link: {
            onClick: (event, attrs) => {
              this.$emit("click-link", event, attrs);
              return true;
            }
          }
        })
      ];
    }
  },
  props: {
    content: {
      type: String,
      required: true
    }
  },
  mounted() {
    this.$el.addEventListener("click", this.preventOpeningLinks, true);
  },
  unmounted() {
    this.$el.removeEventListener("click", this.preventOpeningLinks, true);
  },
  methods: {
    preventOpeningLinks(event) {
      if (event.target.closest("a") && event.button === 0 && !event.ctrlKey) {
        event.preventDefault();
      }
    }
  }
};
var _sfc_render = function render17() {
  var _vm = this, _c = _vm._self._c;
  return _c("BaseReader", { attrs: { "content": _vm.content }, on: { "click-link": (e, a) => _vm.$emit("click-link", e, a) } });
};
var _sfc_staticRenderFns = [];
var __component__ = /* @__PURE__ */ normalizeComponent(
  _sfc_main,
  _sfc_render,
  _sfc_staticRenderFns,
  false,
  null,
  null,
  null,
  null
);
const RichTextReader = __component__.exports;
/**
 * @copyright Copyright (c) 2022 Max <max@nextcloud.com>
 *
 * @author Max <max@nextcloud.com>
 *
 * @license AGPL-3.0-or-later
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
class AttachmentResolver {
  constructor({ session, user, shareToken, currentDirectory, fileId }) {
    __privateAdd(this, _getImageAttachmentUrl);
    __privateAdd(this, _getMediaPreviewUrl);
    __privateAdd(this, _textApiParams);
    __privateAdd(this, _previewUrl);
    __privateAdd(this, _davUrl);
    /**
     * Return the relativePath to a file specified in the url
     *
     * @param {string} src - url to extract path from
     */
    __privateAdd(this, _relativePath);
    __privateAdd(this, _filePath);
    __privateAdd(this, _session, void 0);
    __privateAdd(this, _user, void 0);
    __privateAdd(this, _shareToken, void 0);
    __privateAdd(this, _currentDirectory, void 0);
    __privateAdd(this, _attachmentDirectory, void 0);
    __publicField(this, "ATTACHMENT_TYPE_IMAGE", "image");
    __publicField(this, "ATTACHMENT_TYPE_MEDIA", "media");
    __privateSet(this, _session, session);
    __privateSet(this, _user, user);
    __privateSet(this, _shareToken, shareToken);
    __privateSet(this, _currentDirectory, currentDirectory);
    fileId || (fileId = session == null ? void 0 : session.documentId);
    __privateSet(this, _attachmentDirectory, `.attachments.${fileId}`);
  }
  /*
   * Resolve a given src.
   * @param { string } the original src in the node.
   * @param { bool } choose to fetch the raw image or a preview | default = false
   * @returns { Array<Object> } - resolved candidates to try.
   *
   * Currently returns either one or two urls.
   */
  async resolve(src, preferRawImage = false) {
    var _a2, _b2;
    if (__privateGet(this, _session) && src.startsWith("text://")) {
      const imageFileName = getQueryVariable(src, "imageFileName");
      return [{
        type: this.ATTACHMENT_TYPE_IMAGE,
        url: __privateMethod(this, _getImageAttachmentUrl, getImageAttachmentUrl_fn).call(this, imageFileName, preferRawImage)
      }];
    }
    if (__privateGet(this, _session) && src.startsWith(`.attachments.${(_a2 = __privateGet(this, _session)) == null ? void 0 : _a2.documentId}/`)) {
      const imageFileName = decodeURIComponent(src.replace(`.attachments.${(_b2 = __privateGet(this, _session)) == null ? void 0 : _b2.documentId}/`, "").split("?")[0]);
      return [
        {
          type: this.ATTACHMENT_TYPE_IMAGE,
          url: __privateMethod(this, _getImageAttachmentUrl, getImageAttachmentUrl_fn).call(this, imageFileName, preferRawImage)
        },
        {
          type: this.ATTACHMENT_TYPE_MEDIA,
          url: __privateMethod(this, _getMediaPreviewUrl, getMediaPreviewUrl_fn).call(this, imageFileName),
          name: imageFileName
        }
      ];
    }
    if (isDirectUrl(src)) {
      return [{
        type: this.ATTACHMENT_TYPE_IMAGE,
        url: src
      }];
    }
    if (hasPreview(src)) {
      return [{
        type: this.ATTACHMENT_TYPE_IMAGE,
        url: __privateMethod(this, _previewUrl, previewUrl_fn).call(this, src)
      }];
    }
    if (__privateGet(this, _session) && src.match(/^\.attachments\.\d+\//)) {
      const imageFileName = __privateMethod(this, _relativePath, relativePath_fn).call(this, src).replace(/\.attachments\.\d+\//, "");
      return [
        {
          type: this.ATTACHMENT_TYPE_IMAGE,
          url: __privateMethod(this, _davUrl, davUrl_fn).call(this, src)
        },
        {
          type: this.ATTACHMENT_TYPE_IMAGE,
          url: __privateMethod(this, _getImageAttachmentUrl, getImageAttachmentUrl_fn).call(this, imageFileName, preferRawImage)
        },
        {
          type: this.ATTACHMENT_TYPE_MEDIA,
          url: __privateMethod(this, _getMediaPreviewUrl, getMediaPreviewUrl_fn).call(this, imageFileName),
          name: imageFileName
        }
      ];
    }
    if (!__privateGet(this, _session) && src.match(/^\.attachments\.\d+\//)) {
      const imageFileName = __privateMethod(this, _relativePath, relativePath_fn).call(this, src).replace(/\.attachments\.\d+\//, "");
      const { mimeType, size } = await this.getMetadata(__privateMethod(this, _davUrl, davUrl_fn).call(this, src));
      return [
        {
          type: this.ATTACHMENT_TYPE_IMAGE,
          url: __privateMethod(this, _davUrl, davUrl_fn).call(this, src)
        },
        {
          type: this.ATTACHMENT_TYPE_MEDIA,
          url: this.getMimeUrl(mimeType),
          metadata: { size },
          name: imageFileName
        }
      ];
    }
    return [{
      type: this.ATTACHMENT_TYPE_IMAGE,
      url: __privateMethod(this, _davUrl, davUrl_fn).call(this, src)
    }];
  }
  getMediaMetadataUrl(mediaFileName) {
    if (__privateGet(this, _user) || !__privateGet(this, _shareToken)) {
      return generateUrl("/apps/text/mediaMetadata?documentId={documentId}&sessionId={sessionId}&sessionToken={sessionToken}&mediaFileName={mediaFileName}", {
        ...__privateMethod(this, _textApiParams, textApiParams_fn).call(this),
        mediaFileName
      });
    }
    return generateUrl("/apps/text/mediaMetadata?documentId={documentId}&sessionId={sessionId}&sessionToken={sessionToken}&mediaFileName={mediaFileName}&shareToken={shareToken}", {
      ...__privateMethod(this, _textApiParams, textApiParams_fn).call(this),
      mediaFileName,
      shareToken: __privateGet(this, _shareToken)
    });
  }
  async getMetadata(src) {
    const headResponse = await axios.head(src);
    const mimeType = headResponse.headers["content-type"];
    const size = formatFileSize(headResponse.headers["content-length"]);
    return { mimeType, size };
  }
  getMimeUrl(mimeType) {
    return mimeType ? OC.MimeType.getIconUrl(mimeType) : null;
  }
}
_session = new WeakMap();
_user = new WeakMap();
_shareToken = new WeakMap();
_currentDirectory = new WeakMap();
_attachmentDirectory = new WeakMap();
_getImageAttachmentUrl = new WeakSet();
getImageAttachmentUrl_fn = function(imageFileName, preferRawImage = false) {
  if (!__privateGet(this, _session)) {
    return __privateMethod(this, _davUrl, davUrl_fn).call(this, `${__privateGet(this, _attachmentDirectory)}/${imageFileName}`);
  }
  if (__privateGet(this, _user) || !__privateGet(this, _shareToken)) {
    return generateUrl("/apps/text/image?documentId={documentId}&sessionId={sessionId}&sessionToken={sessionToken}&imageFileName={imageFileName}&preferRawImage={preferRawImage}", {
      ...__privateMethod(this, _textApiParams, textApiParams_fn).call(this),
      imageFileName,
      preferRawImage: preferRawImage ? 1 : 0
    });
  }
  return generateUrl("/apps/text/image?documentId={documentId}&sessionId={sessionId}&sessionToken={sessionToken}&imageFileName={imageFileName}&shareToken={shareToken}&preferRawImage={preferRawImage}", {
    ...__privateMethod(this, _textApiParams, textApiParams_fn).call(this),
    imageFileName,
    shareToken: __privateGet(this, _shareToken),
    preferRawImage: preferRawImage ? 1 : 0
  });
};
_getMediaPreviewUrl = new WeakSet();
getMediaPreviewUrl_fn = function(mediaFileName) {
  if (__privateGet(this, _user) || !__privateGet(this, _shareToken)) {
    return generateUrl("/apps/text/mediaPreview?documentId={documentId}&sessionId={sessionId}&sessionToken={sessionToken}&mediaFileName={mediaFileName}", {
      ...__privateMethod(this, _textApiParams, textApiParams_fn).call(this),
      mediaFileName
    });
  }
  return generateUrl("/apps/text/mediaPreview?documentId={documentId}&sessionId={sessionId}&sessionToken={sessionToken}&mediaFileName={mediaFileName}&shareToken={shareToken}", {
    ...__privateMethod(this, _textApiParams, textApiParams_fn).call(this),
    mediaFileName,
    shareToken: __privateGet(this, _shareToken)
  });
};
_textApiParams = new WeakSet();
textApiParams_fn = function() {
  if (__privateGet(this, _session)) {
    return {
      documentId: __privateGet(this, _session).documentId,
      sessionId: __privateGet(this, _session).id,
      sessionToken: __privateGet(this, _session).token
    };
  }
  return {};
};
_previewUrl = new WeakSet();
previewUrl_fn = function(src) {
  const imageFileId = getQueryVariable(src, "fileId");
  const path = __privateMethod(this, _filePath, filePath_fn).call(this, src);
  const fileQuery = `file=${encodeURIComponent(path)}`;
  const query = fileQuery + "&x=1024&y=1024&a=true";
  if (__privateGet(this, _user) && imageFileId) {
    return generateUrl(`/core/preview?fileId=${imageFileId}&${query}`);
  }
  if (__privateGet(this, _user)) {
    return generateUrl(`/core/preview.png?${query}`);
  }
  if (__privateGet(this, _shareToken)) {
    return generateUrl(`/apps/files_sharing/publicpreview/${__privateGet(this, _shareToken)}?${query}`);
  }
  logger.error("No way to authenticate image retrival - need to be logged in or provide a token");
  return src;
};
_davUrl = new WeakSet();
davUrl_fn = function(src) {
  if (__privateGet(this, _user)) {
    const uid = __privateGet(this, _user).uid;
    const encoded = encodeURI(__privateMethod(this, _filePath, filePath_fn).call(this, src));
    return generateRemoteUrl(`dav/files/${uid}${encoded}`);
  }
  const path = __privateMethod(this, _filePath, filePath_fn).call(this, src).split("/");
  const basename = path.pop();
  const dirname = path.join("/");
  return generateUrl("/s/{token}/download?path={dirname}&files={basename}", {
    token: __privateGet(this, _shareToken),
    basename,
    dirname
  });
};
_relativePath = new WeakSet();
relativePath_fn = function(src) {
  if (src.startsWith("text://")) {
    return [
      __privateGet(this, _attachmentDirectory),
      getQueryVariable(src, "imageFileName")
    ].join("/");
  }
  return decodeURI(src.split("?")[0]);
};
_filePath = new WeakSet();
filePath_fn = function(src) {
  const f = [
    __privateGet(this, _currentDirectory),
    __privateMethod(this, _relativePath, relativePath_fn).call(this, src)
  ].join("/");
  return pathNormalize(f);
};
function isDirectUrl(src) {
  return src.startsWith("http://") || src.startsWith("https://") || src.startsWith("data:") || src.match(/^(\/index.php)?\/core\/preview/) || src.match(/^(\/index.php)?\/apps\/files_sharing\/publicpreview\//);
}
function hasPreview(src) {
  return getQueryVariable(src, "hasPreview") === "true";
}
function getQueryVariable(src, variable) {
  const query = src.split("?")[1];
  if (typeof query === "undefined") {
    return;
  }
  const vars = query.split(/[&#]/);
  if (typeof vars === "undefined") {
    return;
  }
  for (let i = 0; i < vars.length; i++) {
    const pair = vars[i].split("=");
    if (decodeURIComponent(pair[0]) === variable) {
      return decodeURIComponent(pair[1]);
    }
  }
}
export {
  ATTACHMENT_RESOLVER,
  AttachmentResolver,
  OUTLINE_ACTIONS,
  OUTLINE_STATE,
  RichTextReader
};
